/*
 * ImportGeneration.java
 *
 * Created on 3.12.2011, 16:34:47
 */
package gui;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.StringWriter;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map.Entry;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.table.DefaultTableModel;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import org.apache.commons.codec.binary.Base64;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 *
 * @author marek
 */
public class ImportGeneration extends java.awt.Dialog {

    HashMap<File, Document> map;

    /** Creates new form ImportGeneration */
    public ImportGeneration(java.awt.Frame parent, boolean modal, HashMap<File, Document> map) {
        super(parent, modal);
        initComponents();
        setLocationRelativeTo(parent);
        this.map = map;
        setTable();
    }

    private void setTable() {
        Iterator iterator = map.entrySet().iterator();
        while (iterator.hasNext()) {
            DefaultTableModel model = (DefaultTableModel) jTable1.getModel();
            Element root = map.get((File) ((Entry) iterator.next()).getKey()).getDocumentElement();
            String name = "";
            String questiontext = "";
            String namespace = root.getAttributes().getNamedItem("xmlns").getNodeValue();
            String typ = namespace.substring(namespace.lastIndexOf("/") + 1, namespace.length());
            if (root.getElementsByTagName("name").item(0).getChildNodes().getLength() != 0) {
                name = root.getElementsByTagName("name").item(0).getChildNodes().item(0).getNodeValue();
            }
            if (root.getElementsByTagName("questiontext").item(0).getChildNodes().getLength() != 0) {
                questiontext = root.getElementsByTagName("questiontext").item(0).getChildNodes().item(0).getNodeValue();
            }
            model.addRow(new Object[]{typ, name, questiontext, 1, 0.1});
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        generateButton = new javax.swing.JButton();

        setBackground(new java.awt.Color(240, 240, 240));
        setTitle("Create import");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jScrollPane1.setBorder(null);

        jTable1.setFont(new java.awt.Font("Arial", 0, 14)); // NOI18N
        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Typ otazky", "Nazov otazky", "Text otazky", "Maximalne hodnotenie", "Penalty"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.Double.class, java.lang.Float.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false, true, true
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable1.setColumnSelectionAllowed(true);
        jTable1.setDoubleBuffered(true);
        jTable1.getTableHeader().setReorderingAllowed(false);
        jScrollPane1.setViewportView(jTable1);

        generateButton.setText("Generate");
        generateButton.setDoubleBuffered(true);
        generateButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                generateButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 807, Short.MAX_VALUE)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(generateButton)
                .addGap(10, 10, 10))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 368, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(generateButton, javax.swing.GroupLayout.PREFERRED_SIZE, 54, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog

    private void generateButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_generateButtonActionPerformed
        FileInputStream fin = null;
        try {
            //get table model
            DefaultTableModel model = (DefaultTableModel) jTable1.getModel();
            //create document
            DocumentBuilderFactory documentBuilderFactory = DocumentBuilderFactory.newInstance();
            DocumentBuilder documentBuilder = documentBuilderFactory.newDocumentBuilder();
            Document document = documentBuilder.newDocument();
            //root element quiz
            Element quiz = document.createElement("quiz");
            document.appendChild(quiz);
            //elements question
//            for (int i = 0; i < model.getRowCount(); i++) {
            int i = 0;
            Iterator iterator = map.entrySet().iterator();
            while (iterator.hasNext()) {
                //element question
                Element question = document.createElement("question");
                question.setAttribute("type", (String) model.getValueAt(i, 0));
                //name of question
                Element name = document.createElement("name");
                Element text = document.createElement("text");
                text.appendChild(document.createTextNode((String) model.getValueAt(i, 1)));
                name.appendChild(text);
                question.appendChild(name);
                //questiontext of question
                Element questiontext = document.createElement("questiontext");
                questiontext.setAttribute("format", "html");
                text = document.createElement("text");
                text.appendChild(document.createCDATASection("<p>" + (String) model.getValueAt(i, 2) + "</p>"));
                questiontext.appendChild(text);
                question.appendChild(questiontext);
                //feedback 
                Element feedback = document.createElement("generalfeedback");
                feedback.setAttribute("format", "html");
                Element text2 = document.createElement("text");
                feedback.appendChild(text2);
                question.appendChild(feedback);
                //defaultgrade
                Element defaultgrade = document.createElement("defaultgrade");
                defaultgrade.appendChild(document.createTextNode(String.valueOf(model.getValueAt(i, 3))));
                question.appendChild(defaultgrade);
                //penalty
                Element penalty = document.createElement("penalty");
                penalty.appendChild(document.createTextNode(String.valueOf(model.getValueAt(i, 4))));
                question.appendChild(penalty);
                //hidden
                Element hidden = document.createElement("hidden");
                hidden.appendChild(document.createTextNode("0"));
                question.appendChild(hidden);
                //shuffleanswers
                Element shuffleanswers = document.createElement("shuffleanswers");
                shuffleanswers.appendChild(document.createTextNode("0"));
                question.appendChild(shuffleanswers);
                //file
                Element file = document.createElement("file");
                File sourcefile = (File) ((Entry) iterator.next()).getKey();
                String filename = sourcefile.getName();
                String extension = filename.substring(filename.lastIndexOf(".") + 1, filename.length());
                if (extension.equals("xml")) {
                    file.setAttribute("name", filename);
                    file.setAttribute("encoding", "base64");
                    fin = new FileInputStream(sourcefile);
                    byte[] fileContent = new byte[(int) sourcefile.length()];
                    fin.read(fileContent);
                    String encodedFile = Base64.encodeBase64String(fileContent);
                    file.appendChild(document.createTextNode(encodedFile));
                } else {
                    file.setAttribute("name", filename.substring(0, filename.lastIndexOf(".")) + "xml");
                    file.setAttribute("encoding", "base64");
                    Source source = new DOMSource(map.get(sourcefile));
                    ByteArrayOutputStream out = new ByteArrayOutputStream();
                    Result result = new StreamResult(out);
                    TransformerFactory factory = TransformerFactory.newInstance();
                    Transformer transformer = factory.newTransformer();
                    transformer.transform(source, result);
                    String encodedFile = Base64.encodeBase64String(out.toByteArray());
                    file.appendChild(document.createTextNode(encodedFile));
                }
                question.appendChild(file);
                //add question to quiz
                quiz.appendChild(question);
                i++;
            }
            JFileChooser chooser = new JFileChooser();
            FileNameExtensionFilter filter = new FileNameExtensionFilter(".xml", "xml");
            chooser.setFileFilter(filter);
            chooser.setSelectedFile(new File("import.xml"));
            int returnVal = chooser.showSaveDialog(this);
            if (returnVal == JFileChooser.APPROVE_OPTION) {
                TransformerFactory transformerFactory = TransformerFactory.newInstance();
                Transformer transformer = transformerFactory.newTransformer();
                StreamResult result = new StreamResult(new File(chooser.getSelectedFile().getAbsolutePath()));
                transformer.transform(new DOMSource(document), result);
            }
        } catch (FileNotFoundException ex) {
            Logger.getLogger(ImportGeneration.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(ImportGeneration.class.getName()).log(Level.SEVERE, null, ex);
        } catch (TransformerConfigurationException ex) {
            Logger.getLogger(ImportGeneration.class.getName()).log(Level.SEVERE, null, ex);
        } catch (TransformerException ex) {
            Logger.getLogger(ImportGeneration.class.getName()).log(Level.SEVERE, null, ex);
        } catch (ParserConfigurationException ex) {
            Logger.getLogger(ImportGeneration.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            try {
                fin.close();
            } catch (IOException ex) {
                Logger.getLogger(ImportGeneration.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        setVisible(false);
        dispose();
    }//GEN-LAST:event_generateButtonActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton generateButton;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTable1;
    // End of variables declaration//GEN-END:variables
}
