package it4kt.image.data;

import java.awt.image.BufferedImage;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.imageio.ImageIO;
import org.apache.commons.codec.binary.Base64;

/**
 * Zakladna definicia otazky mbimage pre pick definition, obsahuje nazov otazky, text otazky, obrazok a mozne odpovede na otazku.
 * @author marek
 */
public class PickDefinition {

    private String name;
    private String questiontext;
    private BufferedImage image;
    private String imageName;
    private boolean singleselect;
    private List<Answer> answers;

    /*
     * Vytvaranie definicie otazky.
     */
    public PickDefinition(String name, String questiontext, BufferedImage image, String imageName, boolean singleselect, List<Answer> answers) {
        this.name = name;
        this.questiontext = questiontext;
        this.image = image;
        this.imageName = imageName;
        this.singleselect = singleselect;
        this.answers = answers;
    }

    /**
     * @return the name
     */
    public String getName() {
        return name;
    }

    /**
     * @return the questiontext
     */
    public String getQuestiontext() {
        return questiontext;
    }

    /**
     * @return the image in base64 string
     */
    public String getImage() {
        if (image != null) {
            try {
                ByteArrayOutputStream os = new ByteArrayOutputStream();
                ImageIO.write(image, "png", os);
                String stringArray = Base64.encodeBase64String(os.toByteArray());
                return stringArray;
            } catch (IOException ex) {
                Logger.getLogger(SelectAreaDefinition.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        return "";
    }

    /**
     * @return the imageName
     */
    public String getImageName() {
        return imageName;
    }

    /**
     * @return the singleselect
     */
    public boolean getSingleselect() {
        return singleselect;
    }

    /**
     * @return the answers
     */
    public List<Answer> getAnswers() {
        return answers;
    }
}
