/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package it4kt.image.data;

import java.awt.image.BufferedImage;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.imageio.ImageIO;
import org.apache.commons.codec.binary.Base64;

/**
 *
 * @author marek
 */
public class SelectAreaDefinition {

    private String name;
    private String questiontext;
    private BufferedImage image;
    private String imageName;
    private int x;
    private int y;
    private int width;
    private int height;

    public SelectAreaDefinition(String name, String questiontext, BufferedImage image, String imageName, int x, int y, int width, int height) {
        this.name = name;
        this.questiontext = questiontext;
        this.image = image;
        this.imageName = imageName;
        this.x = x;
        this.y = y;
        this.width = width;
        this.height = height;
    }

    /**
     * @return the name
     */
    public String getName() {
        return name;
    }

    /**
     * @return the questiontext
     */
    public String getQuestiontext() {
        return questiontext;
    }

    /**
     * @return the image
     */
    public String getImage() {
        if (image != null) {
            try {
                ByteArrayOutputStream os = new ByteArrayOutputStream();
                ImageIO.write(image, "png", os);
                String stringArray = Base64.encodeBase64String(os.toByteArray());
                return stringArray;
            } catch (IOException ex) {
                Logger.getLogger(SelectAreaDefinition.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        return "";
    }

    /**
     * @return the x
     */
    public int getX() {
        return x;
    }

    /**
     * @return the y
     */
    public int getY() {
        return y;
    }

    /**
     * @return the width
     */
    public int getWidth() {
        return width;
    }

    /**
     * @return the height
     */
    public int getHeight() {
        return height;
    }

    /**
     * @return the imageName
     */
    public String getImageName() {
        return imageName;
    }
}
