/*
 * DesignPanel.java
 *
 * Created on 20.11.2011, 22:16:17
 */
package it4kt.image.graphic.panels;

import exceptions.ValidationException;
import it4kt.image.graphic.ImageComponentPick;
import it4kt.image.graphic.Polygon2D;
import it4kt.image.graphic.dialogs.ResizeDialog2;
import java.awt.event.KeyEvent;
import java.awt.geom.*;
import java.awt.image.BufferedImage;
import java.io.*;
import java.util.*;
import java.util.logging.*;
import javax.imageio.ImageIO;
import javax.swing.*;
import javax.swing.filechooser.FileNameExtensionFilter;
import it4kt.image.data.Answer;
import it4kt.image.data.PickDefinition;
import org.apache.commons.codec.binary.Base64;
import org.w3c.dom.*;

/**
 *
 * @author marek
 */
public class DesignPanelPick extends javax.swing.JPanel {

    DefaultListModel model;
    ImageComponentPick imageComponent;

    /** Creates new form DesignPanel */
    public DesignPanelPick(Document document) {
        initComponents();
        initQuestion(document);
        if(!moreAnswersRadioButton.isSelected()) {
            singleAnswerRadioButton.setSelected(true);
        }        
    }

    /**
     * Metoda nastavuje hodnoty pre otazku mbimage pick
     * Ak dokument existuje potom sa nastavia hodnoty otazky z tohto dokumentu.
     * Ak dokument neexistuje potom sa nastavia preddefinovane hodnoty.
     * @param document 
     */
    private void initQuestion(Document document) {
        if (document != null) {

            Element root = document.getDocumentElement();
            if (root.getElementsByTagName("name").item(0).getChildNodes().getLength() != 0) {
                questionNameTextField.setText(root.getElementsByTagName("name").item(0).getChildNodes().item(0).getNodeValue());
            }
            if (root.getElementsByTagName("questiontext").item(0).getChildNodes().getLength() != 0) {
                textOtazkyTextArea.setText(root.getElementsByTagName("questiontext").item(0).getChildNodes().item(0).getNodeValue());
            }
            try {
                byte[] imageBytes = Base64.decodeBase64(root.getElementsByTagName("image").item(0).getChildNodes().item(0).getNodeValue());
                InputStream in = new ByteArrayInputStream(imageBytes);
                BufferedImage image = ImageIO.read(in);
                imageComponent = new ImageComponentPick(image, root.getElementsByTagName("image").item(0).getAttributes().getNamedItem("name").getChildNodes().item(0).getNodeValue(), this);
                imageComponent.setSize(image.getWidth(), image.getHeight());
                insertImage();
                jTextField1.setText("100");
                //imageComponent.setSelection(Integer.parseInt(root.getElementsByTagName("x").item(0).getChildNodes().item(0).getNodeValue()), Integer.parseInt(root.getElementsByTagName("y").item(0).getChildNodes().item(0).getNodeValue()), Integer.parseInt(root.getElementsByTagName("width").item(0).getChildNodes().item(0).getNodeValue()), Integer.parseInt(root.getElementsByTagName("height").item(0).getChildNodes().item(0).getNodeValue()));
                if (root.getElementsByTagName("singleselect").item(0).getChildNodes().item(0).getNodeValue().equals("true")) {
                    singleAnswerRadioButton.setSelected(true);
                } else {
                    moreAnswersRadioButton.setSelected(true);
                }
                NodeList answers = root.getElementsByTagName("answer");
                for (int i = 0; i < answers.getLength(); i++) {
                    Element element = (Element) answers.item(i);
                    if (element.getElementsByTagName("shape").item(0).getChildNodes().item(0).getNodeValue().equals("rect")) {
                        int x = Integer.parseInt(element.getElementsByTagName("p").item(0).getChildNodes().item(0).getNodeValue());
                        int y = Integer.parseInt(element.getElementsByTagName("p").item(1).getChildNodes().item(0).getNodeValue());
                        int x1 = Integer.parseInt(element.getElementsByTagName("p").item(2).getChildNodes().item(0).getNodeValue());
                        int y1 = Integer.parseInt(element.getElementsByTagName("p").item(3).getChildNodes().item(0).getNodeValue());
                        String description = "";
                        if (element.getElementsByTagName("description").item(0).getChildNodes().getLength() != 0) {
                            description = element.getElementsByTagName("description").item(0).getChildNodes().item(0).getNodeValue();
                        }
                        imageComponent.addSelection(new Answer("rect", new Rectangle2D.Double(x, y, x1 - x, y1 - y), description, Integer.valueOf(element.getElementsByTagName("code").item(0).getChildNodes().item(0).getNodeValue()), Integer.valueOf(element.getElementsByTagName("correct").item(0).getChildNodes().item(0).getNodeValue())));
                    } else if (element.getElementsByTagName("shape").item(0).getChildNodes().item(0).getNodeValue().equals("circle")) {
                        int x = Integer.parseInt(element.getElementsByTagName("p").item(0).getChildNodes().item(0).getNodeValue());
                        int y = Integer.parseInt(element.getElementsByTagName("p").item(1).getChildNodes().item(0).getNodeValue());
                        int x1 = Integer.parseInt(element.getElementsByTagName("p").item(2).getChildNodes().item(0).getNodeValue());
                        String description = "";
                        if (element.getElementsByTagName("description").item(0).getChildNodes().getLength() != 0) {
                            description = element.getElementsByTagName("description").item(0).getChildNodes().item(0).getNodeValue();
                        }
                        imageComponent.addSelection(new Answer("circle", new Ellipse2D.Double(x - x1, y - x1, x1 * 2, x1 * 2), description, Integer.valueOf(element.getElementsByTagName("code").item(0).getChildNodes().item(0).getNodeValue()), Integer.valueOf(element.getElementsByTagName("correct").item(0).getChildNodes().item(0).getNodeValue())));
                    } else {
                        Polygon2D.Double poly = new Polygon2D.Double();
                        int j = 0;
                        while (j < element.getElementsByTagName("p").getLength()) {
                            poly.addPoint(Integer.parseInt(element.getElementsByTagName("p").item(j).getChildNodes().item(0).getNodeValue()), Integer.parseInt(element.getElementsByTagName("p").item(j + 1).getChildNodes().item(0).getNodeValue()));
                            j++;
                            j++;
                        }
                        String description = "";
                        if (element.getElementsByTagName("description").item(0).getChildNodes().getLength() != 0) {
                            description = element.getElementsByTagName("description").item(0).getChildNodes().item(0).getNodeValue();
                        }
                        imageComponent.addSelection(new Answer("poly", poly, description, Integer.valueOf(element.getElementsByTagName("code").item(0).getChildNodes().item(0).getNodeValue()), Integer.valueOf(element.getElementsByTagName("correct").item(0).getChildNodes().item(0).getNodeValue())));

                    }
                }
                imageComponent.setShapeType("rect");
            } catch (IOException ex) {
                Logger.getLogger(DesignPanelPick.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

    /**
     * Metoda pozbiera informacie z formulara a vytvori info(definujuce otazku) o otazke mbimage pick. Udaje su tiez kontrolovane.
     * Skontroluje ci su udaje v poriadku. 
     * Pouziva sa pri generovani vysledneho xml suboru.
     * @return vrati info o otazke
     * @throws ValidationException ak otazka nesplna kriteria
     */
    public PickDefinition getPickDefinition() throws ValidationException {
        if (questionNameTextField.getText().isEmpty()) {
            throw new ValidationException("Nazov otazky musi byt definovany!");
        }
        if (imageComponent == null) {
            throw new ValidationException("Nie je definovany obrazok");
        }
        List<Answer> answers = imageComponent.getSelection();
        if (answers.size() < 3) {
            throw new ValidationException("Musia byt definovane minimalne tri oznacenia");
        }
        boolean isCorrect = false;
        for (int i = 0; i < answers.size(); i++) {
            if (answers.get(i).getCorrect() == 1) {
                isCorrect = true;
                break;
            }
        }
        if (!isCorrect) {
            throw new ValidationException("Jedna z odpovedu musi byt spravna.");
        }
        return new PickDefinition(questionNameTextField.getText(), textOtazkyTextArea.getText(), imageComponent.getImage(), imageComponent.getImageName(), singleAnswerRadioButton.isSelected(), answers);
    }

    /**
     * Metoda pozbiera informacie z formulara a vytvori info(definujuce otazku) o otazke mbimage pick. Udaje nie su kontrolovane.
     * Pouziva sa pri nahlaiadnuti xml v programe(je to len informativne xml nie je potrebna kontrola). 
     * @return info o otazke
     */
    public PickDefinition getPickDef() {
        if (imageComponent != null) {
            List<Answer> answers = imageComponent.getSelection();
            return new PickDefinition(questionNameTextField.getText(), textOtazkyTextArea.getText(), imageComponent.getImage(), imageComponent.getImageName(), singleAnswerRadioButton.isSelected(), answers);
        } else {
            return new PickDefinition(questionNameTextField.getText(), textOtazkyTextArea.getText(), null, "", true, new ArrayList<Answer>());
        }
    }

    /**
     * nastavuje typ tvaru, ktory ma byt zobrazeny
     * @param shape 
     */
    public void setShape(String shape) {
        if (shape.equals("rect")) {
            rectToggleButton.setSelected(true);
        } else if (shape.equals("circle")) {
            circleToggleButton.setSelected(true);
        } else {
            polyToggleButton.setSelected(true);
        }
    }

    /**
     * vrati opis odpovede
     * @return 
     */
    public String getDescription() {
        return descriptionTextArea.getText();
    }

    /**
     * vrati ci je odpoved spravna alebo nie 
     * @return 
     */
    public int getCorrect() {
        if (correctCheckBox.isSelected()) {
            return 1;
        } else {
            return -1;
        }
    }

    /**
     * nastavi odpoved (spravnost odpovede a opis odpovede)
     * @param description
     * @param correct 
     */
    public void setAnswer(String description, int correct) {
        descriptionTextArea.setEnabled(true);
        descriptionTextArea.setText(description);
        correctCheckBox.setEnabled(true);
        if (correct == 1) {
            correctCheckBox.setSelected(true);
        } else {
            correctCheckBox.setSelected(false);
        }
    }

    /**
     * nastavi odpoved
     */
    public void setSelection() {
        imageComponent.setSelection();
    }

    /**
     * nastavi odpovede do listu odpovedi
     * @param ans
     * @param activeShape 
     */
    public void setSelection(List<Answer> ans, int activeShape) {
        if (imageComponent != null) {
            DefaultListModel model = new DefaultListModel();
            for (int i = 0; i < ans.size(); i++) {
                model.addElement(ans.get(i));
            }
            selectionsList.setModel(model);
            if (activeShape != -1) {
                selectionsList.setSelectedIndex(activeShape);
            } else {
                descriptionTextArea.setEnabled(false);
                descriptionTextArea.setText("");
                correctCheckBox.setEnabled(false);
                correctCheckBox.setSelected(false);
            }
        }
    }

    /**
     * Metoda, ktora vlozi obrazok do image panela.
     */
    private void insertImage() {
        imagePanel.removeAll();
        JScrollPane sp = new JScrollPane();
        sp.setBorder(null);
        if (imagePanel.getWidth() < imageComponent.getWidth() && imagePanel.getHeight() < imageComponent.getHeight()) {
            sp.setSize(imagePanel.getWidth(), imagePanel.getHeight());
        } else if (imagePanel.getWidth() < imageComponent.getWidth() && imagePanel.getHeight() > imageComponent.getHeight()) {
            sp.setSize(imagePanel.getWidth(), imagePanel.getHeight());
        } else if (imagePanel.getWidth() > imageComponent.getWidth() && imagePanel.getHeight() < imageComponent.getHeight()) {
            sp.setLocation((imagePanel.getWidth() - imageComponent.getWidth()) / 2, 0);
            sp.setSize(imageComponent.getWidth(), imagePanel.getHeight());
        } else if (imagePanel.getWidth() > imageComponent.getWidth() && imagePanel.getHeight() > imageComponent.getHeight()) {
            sp.setLocation((imagePanel.getWidth() - imageComponent.getWidth()) / 2, (imagePanel.getHeight() - imageComponent.getHeight()) / 2);
            sp.setSize(imageComponent.getWidth(), imageComponent.getHeight());
        }
        sp.setViewportView(imageComponent);
        imagePanel.add(sp);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        selectionButtonGroup = new javax.swing.ButtonGroup();
        answersCountButtonGroup = new javax.swing.ButtonGroup();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        questionNameTextField = new javax.swing.JTextField();
        imageSettingsPanel = new javax.swing.JPanel();
        uploadButton = new javax.swing.JButton();
        resizeButton = new javax.swing.JButton();
        zoomOutButton = new javax.swing.JButton();
        zoomInButton = new javax.swing.JButton();
        jTextField1 = new javax.swing.JTextField();
        jToolBar1 = new javax.swing.JToolBar();
        rectToggleButton = new javax.swing.JToggleButton();
        circleToggleButton = new javax.swing.JToggleButton();
        polyToggleButton = new javax.swing.JToggleButton();
        imagePanelBorder = new javax.swing.JPanel();
        imagePanel = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        singleAnswerRadioButton = new javax.swing.JRadioButton();
        moreAnswersRadioButton = new javax.swing.JRadioButton();
        correctCheckBox = new javax.swing.JCheckBox();
        descriptionLabel = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        descriptionTextArea = new javax.swing.JTextArea();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        selectionsList = new javax.swing.JList();
        jScrollPane3 = new javax.swing.JScrollPane();
        textOtazkyTextArea = new javax.swing.JTextArea();

        setBackground(new java.awt.Color(255, 255, 255));

        jLabel1.setText("Text otázky :");

        jLabel2.setText("Názov otázky :");

        imageSettingsPanel.setBackground(new java.awt.Color(255, 255, 255));
        imageSettingsPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Nastavenie obrázka"));

        uploadButton.setText("Upload");
        uploadButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                uploadButtonActionPerformed(evt);
            }
        });

        resizeButton.setText("Resize");
        resizeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                resizeButtonActionPerformed(evt);
            }
        });

        zoomOutButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/img/magnifier-zoom-out.png"))); // NOI18N
        zoomOutButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                zoomOutButtonActionPerformed(evt);
            }
        });

        zoomInButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/img/magnifier-zoom-in.png"))); // NOI18N
        zoomInButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                zoomInButtonActionPerformed(evt);
            }
        });

        jTextField1.setEditable(false);

        jToolBar1.setFloatable(false);
        jToolBar1.setRollover(true);

        selectionButtonGroup.add(rectToggleButton);
        rectToggleButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/img/layer-shape.png"))); // NOI18N
        rectToggleButton.setSelected(true);
        rectToggleButton.setFocusable(false);
        rectToggleButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        rectToggleButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        rectToggleButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rectToggleButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(rectToggleButton);

        selectionButtonGroup.add(circleToggleButton);
        circleToggleButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/img/layer-shape-ellipse.png"))); // NOI18N
        circleToggleButton.setFocusable(false);
        circleToggleButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        circleToggleButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        circleToggleButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                circleToggleButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(circleToggleButton);

        selectionButtonGroup.add(polyToggleButton);
        polyToggleButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/img/layer-shape-curve.png"))); // NOI18N
        polyToggleButton.setFocusable(false);
        polyToggleButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        polyToggleButton.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        polyToggleButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                polyToggleButtonActionPerformed(evt);
            }
        });
        jToolBar1.add(polyToggleButton);

        javax.swing.GroupLayout imageSettingsPanelLayout = new javax.swing.GroupLayout(imageSettingsPanel);
        imageSettingsPanel.setLayout(imageSettingsPanelLayout);
        imageSettingsPanelLayout.setHorizontalGroup(
            imageSettingsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(imageSettingsPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(imageSettingsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(imageSettingsPanelLayout.createSequentialGroup()
                        .addComponent(resizeButton)
                        .addGap(18, 18, 18)
                        .addComponent(jToolBar1, javax.swing.GroupLayout.DEFAULT_SIZE, 171, Short.MAX_VALUE))
                    .addGroup(imageSettingsPanelLayout.createSequentialGroup()
                        .addComponent(uploadButton)
                        .addGap(18, 18, 18)
                        .addComponent(zoomOutButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextField1, javax.swing.GroupLayout.DEFAULT_SIZE, 59, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(zoomInButton)))
                .addContainerGap())
        );
        imageSettingsPanelLayout.setVerticalGroup(
            imageSettingsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(imageSettingsPanelLayout.createSequentialGroup()
                .addGap(6, 6, 6)
                .addGroup(imageSettingsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(uploadButton)
                    .addComponent(zoomOutButton)
                    .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, 24, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(zoomInButton))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(imageSettingsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(resizeButton)
                    .addComponent(jToolBar1, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        imagePanelBorder.setBorder(javax.swing.BorderFactory.createTitledBorder(""));

        imagePanel.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(java.awt.event.ComponentEvent evt) {
                imagePanelComponentResized(evt);
            }
        });
        imagePanel.addContainerListener(new java.awt.event.ContainerAdapter() {
            public void componentAdded(java.awt.event.ContainerEvent evt) {
                imagePanelComponentAdded(evt);
            }
        });

        javax.swing.GroupLayout imagePanelLayout = new javax.swing.GroupLayout(imagePanel);
        imagePanel.setLayout(imagePanelLayout);
        imagePanelLayout.setHorizontalGroup(
            imagePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 1157, Short.MAX_VALUE)
        );
        imagePanelLayout.setVerticalGroup(
            imagePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 402, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout imagePanelBorderLayout = new javax.swing.GroupLayout(imagePanelBorder);
        imagePanelBorder.setLayout(imagePanelBorderLayout);
        imagePanelBorderLayout.setHorizontalGroup(
            imagePanelBorderLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(imagePanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        imagePanelBorderLayout.setVerticalGroup(
            imagePanelBorderLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(imagePanel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        jPanel1.setBackground(new java.awt.Color(255, 255, 255));
        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Nastavenie otázky"));
        jPanel1.setPreferredSize(new java.awt.Dimension(155, 98));

        singleAnswerRadioButton.setBackground(new java.awt.Color(255, 255, 255));
        answersCountButtonGroup.add(singleAnswerRadioButton);
        singleAnswerRadioButton.setText("Jedna odpoveď");

        moreAnswersRadioButton.setBackground(new java.awt.Color(255, 255, 255));
        answersCountButtonGroup.add(moreAnswersRadioButton);
        moreAnswersRadioButton.setText("Viac odpovedí");

        correctCheckBox.setBackground(new java.awt.Color(255, 255, 255));
        correctCheckBox.setText("Správna");
        correctCheckBox.setEnabled(false);
        correctCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                correctCheckBoxActionPerformed(evt);
            }
        });

        descriptionLabel.setText("Popis odpovede :");

        descriptionTextArea.setColumns(20);
        descriptionTextArea.setRows(5);
        descriptionTextArea.setEnabled(false);
        descriptionTextArea.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                descriptionTextAreaKeyTyped(evt);
            }
        });
        jScrollPane1.setViewportView(descriptionTextArea);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(singleAnswerRadioButton)
                        .addGap(18, 18, 18)
                        .addComponent(descriptionLabel))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(moreAnswersRadioButton)
                            .addComponent(correctCheckBox))
                        .addGap(18, 18, 18)
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 141, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(12, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(singleAnswerRadioButton)
                    .addComponent(descriptionLabel))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(moreAnswersRadioButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(correctCheckBox))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE))
                .addContainerGap())
        );

        jPanel2.setBackground(new java.awt.Color(255, 255, 255));
        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder("Selekcie"));
        jPanel2.setPreferredSize(new java.awt.Dimension(155, 107));

        selectionsList.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                selectionsListMouseClicked(evt);
            }
        });
        selectionsList.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyTyped(java.awt.event.KeyEvent evt) {
                selectionKeyTyped(evt);
            }
        });
        jScrollPane2.setViewportView(selectionsList);

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 141, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 75, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        textOtazkyTextArea.setColumns(20);
        textOtazkyTextArea.setFont(new java.awt.Font("Tahoma", 0, 11)); // NOI18N
        textOtazkyTextArea.setRows(5);
        jScrollPane3.setViewportView(textOtazkyTextArea);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(imagePanelBorder, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jScrollPane3)
                            .addComponent(jLabel2)
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                .addComponent(jLabel1)
                                .addGap(316, 316, 316))
                            .addComponent(questionNameTextField))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(imageSettingsPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, 280, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, 173, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addComponent(jPanel2, javax.swing.GroupLayout.Alignment.LEADING, 0, 104, Short.MAX_VALUE)
                        .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 104, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(questionNameTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jScrollPane3, 0, 38, Short.MAX_VALUE))
                    .addComponent(imageSettingsPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(imagePanelBorder, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

    private void uploadButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_uploadButtonActionPerformed
        JFileChooser chooser = new JFileChooser();
        FileNameExtensionFilter filter = new FileNameExtensionFilter("Images", "jpeg", "jpg", "JPG", "JPEG", "gif", "png");
        chooser.setFileFilter(filter);
        int returnVal = chooser.showOpenDialog(this);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            try {
                BufferedImage image = ImageIO.read(chooser.getSelectedFile());
                imageComponent = new ImageComponentPick(image, chooser.getSelectedFile().getName(), this);
                imageComponent.setSize(image.getWidth(), image.getHeight());
                imageComponent.setShapeType("rect");
                insertImage();
                jTextField1.setText("100");
            } catch (IOException ioe) {
                ioe.printStackTrace();
            }
        }
    }//GEN-LAST:event_uploadButtonActionPerformed

    private void imagePanelComponentResized(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_imagePanelComponentResized
        if (imageComponent != null) {
            insertImage();
        }
        invalidate();
        updateUI();
        repaint();
    }//GEN-LAST:event_imagePanelComponentResized

    private void imagePanelComponentAdded(java.awt.event.ContainerEvent evt) {//GEN-FIRST:event_imagePanelComponentAdded
        invalidate();
        updateUI();
        repaint();
    }//GEN-LAST:event_imagePanelComponentAdded

    private void zoomOutButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_zoomOutButtonActionPerformed
        int zoom = Integer.parseInt(jTextField1.getText());
        if (zoom != 10) {
            jTextField1.setText(String.valueOf(zoom - 10));

            imageComponent.zoom(((zoom) / 100.0), -0.1);
            insertImage();
            invalidate();
            repaint();

        }
    }//GEN-LAST:event_zoomOutButtonActionPerformed

    private void zoomInButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_zoomInButtonActionPerformed
        int zoom = Integer.parseInt(jTextField1.getText());
        if (zoom != 400) {
            jTextField1.setText(String.valueOf(zoom + 10));

            imageComponent.zoom((zoom) / 100.0, 0.1);
            insertImage();
            invalidate();
            repaint();

        }
    }//GEN-LAST:event_zoomInButtonActionPerformed

private void resizeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_resizeButtonActionPerformed
    if (imageComponent != null) {
        ResizeDialog2 dialog = new ResizeDialog2(null, true, imageComponent);
        dialog.setVisible(true);
        imageComponent.imageResize(dialog.getValue());
        insertImage();
        jTextField1.setText("100");
        repaint();
    } else {
        JOptionPane.showMessageDialog(this, "Nie je k dispozicii ziadny obrazok", "Zmena rozmerov", JOptionPane.INFORMATION_MESSAGE);
    }
}//GEN-LAST:event_resizeButtonActionPerformed

private void rectToggleButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rectToggleButtonActionPerformed
    if (imageComponent != null) {
        imageComponent.setShapeType("rect");
    }
}//GEN-LAST:event_rectToggleButtonActionPerformed

private void circleToggleButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_circleToggleButtonActionPerformed
    if (imageComponent != null) {
        imageComponent.setShapeType("circle");
    }
}//GEN-LAST:event_circleToggleButtonActionPerformed

private void polyToggleButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_polyToggleButtonActionPerformed
    if (imageComponent != null) {
        imageComponent.setShapeType("poly");
    }
}//GEN-LAST:event_polyToggleButtonActionPerformed

    private void correctCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_correctCheckBoxActionPerformed
        if (imageComponent != null) {
            if (correctCheckBox.isSelected()) {
                imageComponent.setCorrect(1, singleAnswerRadioButton.isSelected());
            } else {
                imageComponent.setCorrect(-1, singleAnswerRadioButton.isSelected());
            }
        }
    }//GEN-LAST:event_correctCheckBoxActionPerformed

    private void descriptionTextAreaKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_descriptionTextAreaKeyTyped
        if (imageComponent != null) {
            imageComponent.setDescription(descriptionTextArea.getText());
        }
    }//GEN-LAST:event_descriptionTextAreaKeyTyped

    private void selectionsListMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_selectionsListMouseClicked
        if (imageComponent != null) {
            imageComponent.setSelection(selectionsList.getSelectedIndex());
        }
    }//GEN-LAST:event_selectionsListMouseClicked

    private void selectionKeyTyped(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_selectionKeyTyped
        if (imageComponent != null) {
            if (evt.getKeyCode() != KeyEvent.VK_DELETE) {
                imageComponent.removeSelection(selectionsList.getSelectedIndex());
            }
        }

    }//GEN-LAST:event_selectionKeyTyped
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup answersCountButtonGroup;
    private javax.swing.JToggleButton circleToggleButton;
    private javax.swing.JCheckBox correctCheckBox;
    private javax.swing.JLabel descriptionLabel;
    private javax.swing.JTextArea descriptionTextArea;
    private javax.swing.JPanel imagePanel;
    private javax.swing.JPanel imagePanelBorder;
    private javax.swing.JPanel imageSettingsPanel;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JToolBar jToolBar1;
    private javax.swing.JRadioButton moreAnswersRadioButton;
    private javax.swing.JToggleButton polyToggleButton;
    private javax.swing.JTextField questionNameTextField;
    private javax.swing.JToggleButton rectToggleButton;
    private javax.swing.JButton resizeButton;
    private javax.swing.ButtonGroup selectionButtonGroup;
    private javax.swing.JList selectionsList;
    private javax.swing.JRadioButton singleAnswerRadioButton;
    private javax.swing.JTextArea textOtazkyTextArea;
    private javax.swing.JButton uploadButton;
    private javax.swing.JButton zoomInButton;
    private javax.swing.JButton zoomOutButton;
    // End of variables declaration//GEN-END:variables
}
