/*
 * mbimagePanel.java
 *
 * Created on 18.11.2011, 21:25:14
 */
package it4kt.image.graphic.panels;

import exceptions.ValidationException;
import interfaces.IPanel;
import javax.xml.transform.dom.DOMSource;
import it4kt.image.data.PickDefinition;
import it4kt.image.data.SelectAreaDefinition;
import it4kt.image.utils.XML;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * Hlavna trieda pre otazku mbimage.
 * Spravuje prepinanie medzi designom a nahliadnutim do xml.
 * @author marek
 */
public class MBimagePanel extends javax.swing.JPanel implements IPanel {

    DesignPanelSelectArea designSelectAreaPanel;
    DesignPanelPick designSelectAreaPanel2;
    XMLPanel xml_panel;
    XML XML;

    /** Creates new form mborderPanel */
    public MBimagePanel(Document document) {
        initComponents();
        XML = new XML();
        xml_panel = new XMLPanel();
        designToggleButton.setSelected(true);
        if (document != null) {
            XML.setUrl(document.getBaseURI().substring(6));
            Element root = document.getDocumentElement();
            if (root.getElementsByTagName("imagetype").item(0).getChildNodes().item(0).getNodeValue().equals("selectarea")) {
                designSelectAreaPanel = new DesignPanelSelectArea(document);
                designSelectAreaPanel2 = new DesignPanelPick(null);
                showDesign();
            } else {
                designSelectAreaPanel = new DesignPanelSelectArea(null);
                designSelectAreaPanel2 = new DesignPanelPick(document);
                jPanel2.removeAll();
                designSelectAreaPanel2.setSize(jPanel2.getSize());
                jPanel2.add(designSelectAreaPanel2);
                pickRadioButton.setSelected(true);
            }
        } else {
            designSelectAreaPanel = new DesignPanelSelectArea(document);
            designSelectAreaPanel2 = new DesignPanelPick(document);
            showDesign();
        }


    }

    /**
     * Metoda zneviditelny xml panel, nastavi velkost design panelu a potom ho zobrazi.
     */
    private void showDesign() {
        jPanel2.removeAll();
        designSelectAreaPanel.setSize(jPanel2.getSize());
        jPanel2.add(designSelectAreaPanel);
    }

    /**
     * Vrati DOM strukturu otazky
     * @return
     * @throws ValidationException 
     */
    public DOMSource getXMLContent() throws ValidationException {
        if (pickRadioButton.isSelected()) {
            PickDefinition info = designSelectAreaPanel2.getPickDefinition();
            return XML.generateXML(info);
        } else {
            SelectAreaDefinition info = designSelectAreaPanel.getSelectAreaDefinition();
            return XML.generateXML(info);
        }
    }

    /**
     * Vrati cestu k suboru
     * @return 
     */
    public String getUrlOfFile() {
        return XML.getUrl();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        DesignXMLGroup = new javax.swing.ButtonGroup();
        QuestionTypeGroup = new javax.swing.ButtonGroup();
        jPanel1 = new javax.swing.JPanel();
        designToggleButton = new javax.swing.JToggleButton();
        xmlToggleButton = new javax.swing.JToggleButton();
        selectAreaRadioButton = new javax.swing.JRadioButton();
        pickRadioButton = new javax.swing.JRadioButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jPanel2 = new javax.swing.JPanel();

        setBackground(new java.awt.Color(255, 255, 255));
        addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(java.awt.event.ComponentEvent evt) {
                MBimagePanel.this.componentResized(evt);
            }
        });

        jPanel1.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        DesignXMLGroup.add(designToggleButton);
        designToggleButton.setText("Design");
        designToggleButton.setBorderPainted(false);
        designToggleButton.setFocusPainted(false);
        designToggleButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                designToggleButtonActionPerformed(evt);
            }
        });

        DesignXMLGroup.add(xmlToggleButton);
        xmlToggleButton.setText("XML");
        xmlToggleButton.setBorderPainted(false);
        xmlToggleButton.setMinimumSize(new java.awt.Dimension(64, 22));
        xmlToggleButton.setPreferredSize(new java.awt.Dimension(64, 22));
        xmlToggleButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                xmlToggleButtonActionPerformed(evt);
            }
        });

        QuestionTypeGroup.add(selectAreaRadioButton);
        selectAreaRadioButton.setSelected(true);
        selectAreaRadioButton.setText("Select area");
        selectAreaRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                selectAreaRadioButtonActionPerformed(evt);
            }
        });

        QuestionTypeGroup.add(pickRadioButton);
        pickRadioButton.setText("Pick");
        pickRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pickRadioButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(designToggleButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(xmlToggleButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(selectAreaRadioButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(pickRadioButton)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                .addComponent(designToggleButton, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addComponent(xmlToggleButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addComponent(selectAreaRadioButton)
                .addComponent(pickRadioButton))
        );

        jScrollPane1.setBackground(new java.awt.Color(255, 255, 255));
        jScrollPane1.setBorder(null);

        jPanel2.setBackground(new java.awt.Color(255, 255, 255));
        jPanel2.addContainerListener(new java.awt.event.ContainerAdapter() {
            public void componentAdded(java.awt.event.ContainerEvent evt) {
                MBimagePanel.this.componentAdded(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 557, Short.MAX_VALUE)
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 409, Short.MAX_VALUE)
        );

        jScrollPane1.setViewportView(jPanel2);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jScrollPane1)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void xmlToggleButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_xmlToggleButtonActionPerformed
        jPanel2.removeAll();
        DOMSource source = null;
        if (pickRadioButton.isSelected()) {
            source = XML.generateXML(designSelectAreaPanel2.getPickDef());
        } else {
            source = XML.generateXML(designSelectAreaPanel.getSelectAreaDef());
        }
        xml_panel.setValue(XML.generateStringFromXML(source));
        xml_panel.setSize(jPanel2.getSize());
        jPanel2.add(xml_panel);
        selectAreaRadioButton.setEnabled(false);
        pickRadioButton.setEnabled(false);
    }//GEN-LAST:event_xmlToggleButtonActionPerformed

    private void designToggleButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_designToggleButtonActionPerformed
        if (selectAreaRadioButton.isSelected()) {
            showDesign();
        } else {
            jPanel2.removeAll();
            designSelectAreaPanel2.setSize(jPanel2.getSize());
            designSelectAreaPanel2.setSelection();
            jPanel2.add(designSelectAreaPanel2);
        }
        selectAreaRadioButton.setEnabled(true);
        pickRadioButton.setEnabled(true);
    }//GEN-LAST:event_designToggleButtonActionPerformed

    private void componentAdded(java.awt.event.ContainerEvent evt) {//GEN-FIRST:event_componentAdded
        invalidate();
        updateUI();
        repaint();
    }//GEN-LAST:event_componentAdded

    private void componentResized(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_componentResized
        xml_panel.setSize(jPanel2.getSize());
        designSelectAreaPanel.setSize(jPanel2.getSize());
        designSelectAreaPanel2.setSize(jPanel2.getSize());
        invalidate();
        updateUI();
        repaint();
    }//GEN-LAST:event_componentResized

    private void selectAreaRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_selectAreaRadioButtonActionPerformed
        showDesign();
    }//GEN-LAST:event_selectAreaRadioButtonActionPerformed

private void pickRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pickRadioButtonActionPerformed
    jPanel2.removeAll();
    designSelectAreaPanel2.setSize(jPanel2.getSize());
    jPanel2.add(designSelectAreaPanel2);
}//GEN-LAST:event_pickRadioButtonActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup DesignXMLGroup;
    private javax.swing.ButtonGroup QuestionTypeGroup;
    private javax.swing.JToggleButton designToggleButton;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JRadioButton pickRadioButton;
    private javax.swing.JRadioButton selectAreaRadioButton;
    private javax.swing.JToggleButton xmlToggleButton;
    // End of variables declaration//GEN-END:variables
}
