<?xml version="1.0" encoding="UTF-8"?>

<!--
    Document   : mborder.xsl
    Created on : Štvrtok, 2012, február 9, 20:09
    Author     : marek
    Description:
        Purpose of transformation follows.
-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:php="http://php.net/xsl"
                version="1.0">
    <xsl:output method="xml"/>
    <xsl:template match="/">
        <question xmlns="http://xml.moodle.org/schema/it4kt_match">
            <name>
                <xsl:value-of select="hotpot-jmatch-file/data/title"/>
            </name>
            <questiontext>
                <xsl:value-of select="hotpot-jmatch-file/data/title"/>
            </questiontext>
            <answers>
                <xsl:for-each select="hotpot-jmatch-file/data/matching-exercise/pair">
                    <xsl:variable name="rightitem" select="./right-item/text"/>
                    <xsl:variable name="pathstr" select="substring-after($rightitem,'&amp;#x003C;img src=&quot;')"/>
                    <xsl:variable name="path" select="substring-before($pathstr,'&quot;')"/>
                    <xsl:if test="not(contains($rightitem,'&amp;#x003C;img src=&quot;')) OR contains($path,'http')">
                        <answer>
                            <subquestion>
                                <xsl:value-of select="./left-item/text"/>
                            </subquestion>
                            <xsl:choose>
                                <xsl:when test="contains($rightitem,'&amp;#x003C;img src=&quot;')">
                                    <answerimage>
                                        <xsl:attribute name="encoding">
                                            <xsl:text>base64</xsl:text>
                                        </xsl:attribute>
                                        <xsl:attribute name="name">
                                            <xsl:call-template name="getFilename">
                                                <xsl:with-param name="filename" select="substring-before(substring-after($rightitem,'&amp;#x003C;img src=&quot;'),'&quot;')"/>
                                            </xsl:call-template>
                                        </xsl:attribute>
                                    
                                        <xsl:choose>
                                            <xsl:when test="contains($path,'http://')">
                                                <xsl:value-of select="php:function('encodeImage', $path)"/>
                                            </xsl:when>
                                            <xsl:otherwise>
                                                <xsl:text>error image isn't on the web</xsl:text>
                                            </xsl:otherwise>
                                        </xsl:choose> 
                                    </answerimage>
                                </xsl:when>
                                <xsl:otherwise>
                                    <answertext>
                                        <xsl:value-of select="./right-item/text"/>
                                    </answertext>        
                                </xsl:otherwise>
                            </xsl:choose> 
                            <code>
                                <xsl:value-of select="php:function('rand',100000,999999)"/>
                            </code>
                        </answer>
                    </xsl:if> 
                </xsl:for-each>
            </answers>
        </question>
    </xsl:template>

    <xsl:template name="getFilename">
        <xsl:param name="filename"/>
        <xsl:choose>
            <xsl:when test="contains($filename, '/')">
                <xsl:call-template name="getFilename">
                    <xsl:with-param name="filename" select="substring-after($filename, '/')"/>
                </xsl:call-template>
            </xsl:when>
            <xsl:otherwise>
                <xsl:value-of select="$filename"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
</xsl:stylesheet>
