package it4kt.match.graphic;

import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.image.*;
import javax.swing.*;

public class ImageComponent extends JPanel {

    private BufferedImage image;
    private String imageName;

    public ImageComponent(BufferedImage image, String imageName) {
        this.image = image;
        this.imageName = imageName;

        setPreferredSize(new Dimension(image.getWidth(), image.getHeight()));
    }

    public void paintComponent(Graphics g2D) {
        Graphics2D g = (Graphics2D) g2D;
        g.drawImage(image, 0, 0, null);
    }

    /**
     * @return the imageName
     */
    public String getImageName() {
        return imageName;
    }

    public BufferedImage getImage() {
        return image;
    }
}
