package it4kt.match.utils;

import java.awt.Image;
import java.awt.image.BufferedImage;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.Random;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.imageio.ImageIO;
import org.apache.commons.codec.binary.Base64;

/**
 * Trieda odpovede.
 * Odpoved obsahuje - text odpovede, poziciu odpovede a jedinecny kod odpovede
 * @author marek
 */
public class Answer {
    //TODO zabezpecit aby kod bol jedinecny

    private String question;
    private String answertext;
    private Image image;
    private String imageName;
    private int code;

    public Answer(int number) {
        code = new Random(System.currentTimeMillis() * number).nextInt(10000000);
        question = "";
        answertext = "";
        image = null;
    }

    public Answer(String question, String answer, int code) {
        this.answertext = answer;
        this.code = code;
        this.question = question;
    }

    public Answer(String question, Image image, String imageName, int code) {
        this.image = image;
        this.code = code;
        this.question = question;
        this.imageName = imageName;
    }

    /**
     * @return the answer
     */
    public String getAnswertext() {
        return answertext;
    }

    /**
     * @param answer the answer to set
     */
    public void setAnswertext(String answertext) {
        this.answertext = answertext;
    }

    /**
     * @return the code
     */
    public int getCode() {
        return code;
    }

    /**
     * @return the question
     */
    public String getQuestion() {
        return question;
    }

    /**
     * @param question the question to set
     */
    public void setQuestion(String question) {
        this.question = question;
    }

    /**
     * @return the image
     */
    public Image getImage() {
        return image;
    }

    /**
     * @param image the image to set
     */
    public void setImage(Image image) {
        this.image = image;
    }

    /**
     * @return the imageName
     */
    public String getImageName() {
        return imageName;
    }

    /**
     * @param imageName the imageName to set
     */
    public void setImageName(String imageName) {
        this.imageName = imageName;
    }

    public String getImageBin() {
        if (image != null) {
            try { 
                ByteArrayOutputStream os = new ByteArrayOutputStream();
                ImageIO.write((BufferedImage) image, "png", os);
                String stringArray = Base64.encodeBase64String(os.toByteArray());
                return stringArray;
            } catch (IOException ex) {
                Logger.getLogger(Answer.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        return "";
    }
}
