<?xml version="1.0" encoding="UTF-8"?>

<!--
    Document   : mborder.xsl
    Created on : Štvrtok, 2012, február 9, 20:09
    Author     : marek
    Description:
        Purpose of transformation follows.
-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:java="http://xml.apache.org/xslt/java" 
                xmlns:b64="org.apache.commons.codec.binary.Base64"
                xmlns:imgio="javax.imageio.ImageIO"
                xmlns:baos="java.io.ByteArrayOutputStream"
                xmlns:file="java.io.File"
                xmlns:url="java.net.URL"
                version="1.0">
    <xsl:output method="xml"/>
    <xsl:param name="file_loc"/>
    <xsl:template match="/">
        <question xmlns="http://xml.moodle.org/schema/it4kt_match">
            <name>
                <xsl:value-of select="hotpot-jmatch-file/data/title"/>
            </name>
            <questiontext>
                <xsl:value-of select="hotpot-jmatch-file/data/title"/>
            </questiontext>
            <answers>
                <xsl:for-each select="hotpot-jmatch-file/data/matching-exercise/pair">
                    <answer>
                        <subquestion>
                            <xsl:value-of select="./left-item/text"/>
                        </subquestion>
                        <xsl:variable name="rightitem" select="./right-item/text"/>
                        <xsl:choose>
                            <xsl:when test="contains($rightitem,'&amp;#x003C;img src=&quot;')">
                                <answerimage>
                                    <xsl:attribute name="encoding">
                                        <xsl:text>base64</xsl:text>
                                    </xsl:attribute>
                                    <xsl:attribute name="name">
                                        <xsl:call-template name="getFilename">
                                            <xsl:with-param name="filename" select="substring-before(substring-after($rightitem,'&amp;#x003C;img src=&quot;'),'&quot;')"/>
                                        </xsl:call-template>
                                    </xsl:attribute>
                                    <xsl:variable name="pathstr" select="substring-after($rightitem,'&amp;#x003C;img src=&quot;')"/>
                                    <xsl:variable name="path" select="substring-before($pathstr,'&quot;')"/>
                                    <xsl:choose>
                                        <xsl:when test="contains($path,'http://')">
                                            <xsl:variable name="img" select="imgio:read(url:new($path))"/>
                                            <xsl:variable name="bas" select="baos:new()"/>
                                            <xsl:variable name="bool" select="imgio:write($img,'png',$bas)"/>
                                            <xsl:variable name="byte" select="baos:toByteArray($bas)"/>
                                            <xsl:variable name="endstring" select="b64:encodeBase64String($byte)"/>
                                            <xsl:if test="$bool=false">
                                                <xsl:value-of select="$bool"/>
                                            </xsl:if> 
                                            <xsl:value-of select="$endstring"/>
                                            <xsl:value-of select="baos:close($bas)"/>
                                        </xsl:when>
                                        <xsl:otherwise>
                                            <xsl:variable name="img" select="imgio:read(file:new(concat($file_loc,$path)))"/>
                                            <xsl:variable name="bas" select="baos:new()"/>
                                            <xsl:variable name="bool" select="imgio:write($img,'png',$bas)"/>
                                            <xsl:variable name="byte" select="baos:toByteArray($bas)"/>
                                            <xsl:variable name="endstring" select="b64:encodeBase64String($byte)"/>
                                            <xsl:if test="$bool=false">
                                                <xsl:value-of select="$bool"/>
                                            </xsl:if> 
                                            <xsl:value-of select="$endstring"/>
                                            <xsl:value-of select="baos:close($bas)"/>
                                        </xsl:otherwise>
                                    </xsl:choose> 
                                </answerimage>
                            </xsl:when>
                            <xsl:otherwise>
                                <answertext>
                                    <xsl:value-of select="./right-item/text"/>
                                </answertext>        
                            </xsl:otherwise>
                        </xsl:choose> 
                        <code>
                            <xsl:variable name="random" select="java:java.util.Random.new()"/>
                            <xsl:value-of select="format-number(round(999999 * java:nextDouble($random)), '000000')" />
                        </code>
                    </answer>
                </xsl:for-each>
            </answers>
        </question>
    </xsl:template>

    <xsl:template name="getFilename">
        <xsl:param name="filename"/>
        <xsl:choose>
            <xsl:when test="contains($filename, '/')">
                <xsl:call-template name="getFilename">
                    <xsl:with-param name="filename" select="substring-after($filename, '/')"/>
                </xsl:call-template>
            </xsl:when>
            <xsl:otherwise>
                <xsl:value-of select="$filename"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
</xsl:stylesheet>
