package it4kt.order.data;

import java.util.Random;

/**
 * Trieda odpovede.
 * Odpoved obsahuje - text odpovede, poziciu odpovede a jedinecny kod odpovede
 * @author marek
 */
public class Answer {
    //TODO zabezpecit aby kod bol jedinecny

    private String answer;
    private int position;
    private int code;

    /**
     * Vytvara prazdnu odpoved na zadanej poziciou s vygenerovanym kodom.
     * Tento konstruktor sa vyuziva pri inicializovani(pri vytvarani novej) otazky mborder 
     * @param position 
     */
    public Answer(int position) {
        this.position = position;
        code = new Random(System.currentTimeMillis() * position).nextInt(10000000);
        answer = "";
    }

    /**
     * Vytvara odpoved. Pouziva sa vtedy ak otazka uz bola vytvorena a otavara sa zo suboru.
     * @param answer
     * @param position
     * @param code 
     */
    public Answer(String answer, int position, int code) {
        this.answer = answer;
        this.position = position;
        this.code = code;
    }

    /**
     * @return the position
     */
    public int getPosition() {
        return position;
    }

    /**
     * @param position the position to set
     */
    public void setPosition(int position) {
        this.position = position;
    }

    /**
     * @return the answer
     */
    public String getAnswer() {
        return answer;
    }

    /**
     * @param answer the answer to set
     */
    public void setAnswer(String answer) {
        this.answer = answer;
    }

    /**
     * @return the code
     */
    public int getCode() {
        return code;
    }
}
