<?xml version="1.0" encoding="UTF-8"?>

<!--
    Document   : mbpartcode.xsl
    Created on : Štvrtok, 2012, február 9, 20:09
    Author     : marek
    Description:
        Purpose of transformation follows.
        Transform jcl hot potatoes file to xml for it4kt_partcode question.
        name -> title
        questiontext->title
        partcodetype->"text" (allways "text" - hot potatoes don't support question type which can call web service)
        code->gap-fill and template replace-text
        answers->question-record/answer/text
-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:java="http://xml.apache.org/xslt/java"
                version="1.0">
    <xsl:output method="xml"/>
    <xsl:template match="/">
        <question xmlns="http://xml.moodle.org/schema/it4kt_partcode">
            <name>
                <xsl:value-of select="hotpot-jcloze-file/data/title"/>
            </name>
            <questiontext>
                <xsl:value-of select="hotpot-jcloze-file/data/title"/>
            </questiontext>
            <partcodetype>text</partcodetype>
            <text>
                <code>
                    <xsl:call-template name="replace-text">
                        <xsl:with-param name="text" select="hotpot-jcloze-file/data/gap-fill"/>
                        <xsl:with-param name="replaces" select="hotpot-jcloze-file/data/gap-fill/question-record"/>
                        <xsl:with-param name="count" select="1"/>
                    </xsl:call-template>
                </code>
                <replace>
                    <xsl:for-each select="hotpot-jcloze-file/data/gap-fill/question-record">
                        <answers>
                            <xsl:for-each select="./answer/text">
                                <answer>
                                    <xsl:value-of select="."/>
                                </answer>
                            </xsl:for-each>
                        </answers>
                    </xsl:for-each>
                </replace>
            </text>
        </question>
    </xsl:template>
    
    <xsl:template name="replace-text">
        <xsl:param name="text"/>
        <xsl:param name="replaces"/>
        <xsl:param name="count"/>
        <xsl:if test="contains($text, $replaces[$count]/.)">
            <xsl:value-of select="substring-before($text, $replaces[$count]/.)"/>
            <xsl:variable name="number" select="$count"/>
            <xsl:value-of select="concat('$partcode-replace',$number - 1)" disable-output-escaping="yes"/>
            <xsl:choose>
                <xsl:when test="$count &lt; count($replaces)">
                    <xsl:call-template name="replace-text">
                        <xsl:with-param name="text" select="substring-after($text, $replaces[$count]/.)"/>
                        <xsl:with-param name="replaces" select="$replaces"/>
                        <xsl:with-param name="count" select="$count+1"/>
                    </xsl:call-template>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="substring-after($text, $replaces[$count]/.)"/>
                </xsl:otherwise>
            </xsl:choose>
        </xsl:if>
    </xsl:template>
</xsl:stylesheet>
