/*
 * mbimagePanel.java
 *
 * Created on 18.11.2011, 21:25:14
 */
package it4kt.partcode.graphic.panels;

import it4kt.partcode.data.PartCodeDefinitionConnection;
import it4kt.partcode.data.PartCodeDefinitionText;
import exceptions.ValidationException;
import interfaces.IPanel;
import javax.xml.transform.dom.DOMSource;
import it4kt.partcode.utils.XML;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * Hlavna trieda pre otazku mbimage.
 * Spravuje prepinanie medzi designom a nahliadnutim do xml.
 * @author marek
 */
public class MBpartcodePanel extends javax.swing.JPanel implements IPanel {

    DesignPanelText designText;
    DesignPanelConnection designConnection;
    XMLPanel xml_panel;
    XML XML;

    /** Creates new form mborderPanel */
    public MBpartcodePanel(Document document) {
        initComponents();
        XML = new XML();
        xml_panel = new XMLPanel();
        designToggleButton.setSelected(true);
        if (document != null) {
            if (document != null && document.getBaseURI() != null) {
                XML.setUrl(document.getBaseURI().substring(6));
            }
            Element root = document.getDocumentElement();
            if (root.getElementsByTagName("partcodetype").item(0).getChildNodes().item(0).getNodeValue().equals("text")) {
                designText = new DesignPanelText(document);
                designConnection = new DesignPanelConnection(null);
                showDesign();
            } else {
                designText = new DesignPanelText(null);
                designConnection = new DesignPanelConnection(document);
                jPanel2.removeAll();
                designConnection.setSize(jPanel2.getSize());
                jPanel2.add(designConnection);
                connectionsRadioButton.setSelected(true);
            }
        } else {
            designText = new DesignPanelText(document);
            designConnection = new DesignPanelConnection(null);
            showDesign();
        }


    }

    /**
     * Metoda zneviditelny xml panel, nastavi velkost design panelu a potom ho zobrazi.
     */
    private void showDesign() {
        jPanel2.removeAll();
        designText.setSize(jPanel2.getSize());
        jPanel2.add(designText);
    }

    /**
     * Vrati DOM strukturu otazky
     * @return
     * @throws ValidationException 
     */
    public DOMSource getXMLContent() throws ValidationException {
        if (connectionsRadioButton.isSelected()) {
            PartCodeDefinitionConnection info = designConnection.getConnectionDefinition();
            return XML.generateXML(info);
        } else {
            PartCodeDefinitionText info = designText.getTextDefinition();
            return XML.generateXML(info);
        }
    }

    /**
     * Vrati cestu k suboru
     * @return 
     */
    public String getUrlOfFile() {
        return XML.getUrl();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        DesignXMLGroup = new javax.swing.ButtonGroup();
        QuestionTypeGroup = new javax.swing.ButtonGroup();
        jPanel1 = new javax.swing.JPanel();
        designToggleButton = new javax.swing.JToggleButton();
        xmlToggleButton = new javax.swing.JToggleButton();
        textRadioButton = new javax.swing.JRadioButton();
        connectionsRadioButton = new javax.swing.JRadioButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jPanel2 = new javax.swing.JPanel();

        setBackground(new java.awt.Color(255, 255, 255));
        addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(java.awt.event.ComponentEvent evt) {
                MBpartcodePanel.this.componentResized(evt);
            }
        });

        jPanel1.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        DesignXMLGroup.add(designToggleButton);
        designToggleButton.setText("Design");
        designToggleButton.setBorderPainted(false);
        designToggleButton.setFocusPainted(false);
        designToggleButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                designToggleButtonActionPerformed(evt);
            }
        });

        DesignXMLGroup.add(xmlToggleButton);
        xmlToggleButton.setText("XML");
        xmlToggleButton.setBorderPainted(false);
        xmlToggleButton.setMaximumSize(new java.awt.Dimension(64, 22));
        xmlToggleButton.setMinimumSize(new java.awt.Dimension(64, 22));
        xmlToggleButton.setPreferredSize(new java.awt.Dimension(64, 22));
        xmlToggleButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                xmlToggleButtonActionPerformed(evt);
            }
        });

        QuestionTypeGroup.add(textRadioButton);
        textRadioButton.setSelected(true);
        textRadioButton.setText("Text");
        textRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                textRadioButtonActionPerformed(evt);
            }
        });

        QuestionTypeGroup.add(connectionsRadioButton);
        connectionsRadioButton.setText("Connections");
        connectionsRadioButton.setEnabled(false);
        connectionsRadioButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                connectionsRadioButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(designToggleButton, javax.swing.GroupLayout.PREFERRED_SIZE, 64, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(xmlToggleButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(textRadioButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(connectionsRadioButton)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                .addComponent(designToggleButton, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addComponent(xmlToggleButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addComponent(textRadioButton)
                .addComponent(connectionsRadioButton))
        );

        jScrollPane1.setBackground(new java.awt.Color(255, 255, 255));
        jScrollPane1.setBorder(null);

        jPanel2.setBackground(new java.awt.Color(255, 255, 255));
        jPanel2.addContainerListener(new java.awt.event.ContainerAdapter() {
            public void componentAdded(java.awt.event.ContainerEvent evt) {
                MBpartcodePanel.this.componentAdded(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 557, Short.MAX_VALUE)
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 409, Short.MAX_VALUE)
        );

        jScrollPane1.setViewportView(jPanel2);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jScrollPane1)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void xmlToggleButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_xmlToggleButtonActionPerformed
        jPanel2.removeAll();
        DOMSource source = null;
        if (connectionsRadioButton.isSelected()) {
            source = XML.generateXML(designConnection.getConnectionDef());
        } else {
            source = XML.generateXML(designText.getTextDef());
        }
        xml_panel.setValue(XML.generateStringFromXML(source));
        xml_panel.setSize(jPanel2.getSize());
        jPanel2.add(xml_panel);
        textRadioButton.setEnabled(false);
        connectionsRadioButton.setEnabled(false);
    }//GEN-LAST:event_xmlToggleButtonActionPerformed

    private void designToggleButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_designToggleButtonActionPerformed
        if (textRadioButton.isSelected()) {
            showDesign();
        } else {
            jPanel2.removeAll();
            designConnection.setSize(jPanel2.getSize());
            jPanel2.add(designConnection);
        }
        textRadioButton.setEnabled(true);
        connectionsRadioButton.setEnabled(true);
    }//GEN-LAST:event_designToggleButtonActionPerformed

    private void componentAdded(java.awt.event.ContainerEvent evt) {//GEN-FIRST:event_componentAdded
        invalidate();
        updateUI();
        repaint();
    }//GEN-LAST:event_componentAdded

    private void componentResized(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_componentResized
        xml_panel.setSize(jPanel2.getSize());
        designText.setSize(jPanel2.getSize());
        designConnection.setSize(jPanel2.getSize());
        invalidate();
        updateUI();
        repaint();
    }//GEN-LAST:event_componentResized

    private void textRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_textRadioButtonActionPerformed
        showDesign();
    }//GEN-LAST:event_textRadioButtonActionPerformed

private void connectionsRadioButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_connectionsRadioButtonActionPerformed
    jPanel2.removeAll();
    designConnection.setSize(jPanel2.getSize());
    jPanel2.add(designConnection);
}//GEN-LAST:event_connectionsRadioButtonActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup DesignXMLGroup;
    private javax.swing.ButtonGroup QuestionTypeGroup;
    private javax.swing.JRadioButton connectionsRadioButton;
    private javax.swing.JToggleButton designToggleButton;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JRadioButton textRadioButton;
    private javax.swing.JToggleButton xmlToggleButton;
    // End of variables declaration//GEN-END:variables
}
