<?php
/**
 * The editing form code for this question type.
 *
 * @copyright &copy; 2011 Marek Balaz
 * @author peter.vaclavik@tuke.sk
 * @license http://www.gnu.org/copyleft/gpl.html GNU Public License
 * @package it4kt
 *//** */

require_once($CFG->dirroot.'/question/type/edit_question_form.php');

/**
 * it4kt_image editing form definition.
 */
class question_edit_it4kt_image_form extends question_edit_form {

	/**
     * Add filepicker to form. Accepted type of file is xml.
     * @param object $mform the form being built.
     */
    function definition_inner(&$mform) {
		$mform->addElement('filepicker', 'xmlfile', get_string('file'), null, array('maxbytes' => 2048000, 'accepted_types' => '*.xml'));
		$mform->setType('xmlfile', PARAM_TEXT);
		$mform->addRule('xmlfile', null, 'required');
    }

	/**
     * Move file from it4kt_image question area to draft area and set filepicker.
     * @param array $question - array to fill in with the default values
     */
	function data_preprocessing($question) {
       if (isset($question->options)) {
			$draftid = file_get_submitted_draft_itemid('xmlfile');
		 	file_prepare_draft_area(
                        $draftid, // draftid
                        $this->context->id, // context
                        'qtype_it4kt_image', // component
                        'question', // filarea
                        $question->id, // itemid
                        array('maxbytes' => 2048000, 'accepted_types' => '*.xml') // options
            );
            $default_values['xmlfile'] = $draftid;
			$question = (object)((array)$question + $default_values);
		}

		return $question;
    }

	/**
     * Validate xml file witch it4kt_image xsd file.
     */
    function validation($data,$files) {
        global $CFG,$USER;
   		$user_context = get_context_instance(CONTEXT_USER, $USER->id);

		$errors = parent::validation($data, $files);
		$xmlfile = $data['xmlfile'];

		$xml = new DOMDocument();

		$fs = get_file_storage();
		$files = $fs->get_area_files($user_context->id, 'user', 'draft', $xmlfile);

		foreach ($files as $file) {
    		$targetfile = $file;
		}
		$xml->loadXML($targetfile->get_content());

		// Enable user error handling
		libxml_use_internal_errors(true);

		if (!$xml->schemaValidate("$CFG->dirroot/question/type/it4kt_image/validation/mbimage.xsd")) {
   			$errors['xmlfile'] = get_string('wrongxml', 'qtype_it4kt_image');
		}

		return $errors;
    }

    function qtype() {
        return 'it4kt_image';
    }
}
?>