<?php
/**
 * The question type class for the Order question type.
 *
 * @copyright &copy; 2012 Peter Vaclavik
 * @author peter.vaclavik@tuke.sk
 * @license http://www.gnu.org/copyleft/gpl.html GNU Public License
 * @package it4kt
 *//** */

/**
 * The Order question class
 *
 * TODO give an overview of how the class works here.
 */
class it4kt_image_qtype extends default_questiontype {

    function name() {
        return 'it4kt_image';
    }

	/**
     * Allow question types to include required JavaScrip or CSS on pages
     * where they are going to be printed.
     *
     * @param object $question The question object.
     * @param object $state    The state object.
     */
    function get_html_head_contributions(&$question, &$state) {
        global $CFG;
        if (file_exists($CFG->dirroot . '/lib/js/jquery-1.7.1.js')) {
            require_js($CFG->wwwroot . '/lib/js/jquery-1.7.1.js');
        }
        if (file_exists($CFG->dirroot . '/lib/js/jquery.imagemapster.js')) {
            require_js($CFG->wwwroot . '/lib/js/jquery.imagemapster.js');
        }
        if (file_exists($CFG->dirroot . '/lib/js/jquery.imgareaselect.pack.js')) {
            require_js($CFG->wwwroot . '/lib/js/jquery.imgareaselect.pack.js');
        }

        $contributions = parent::get_html_head_contributions($question, $state);

        $baseurl = $this->plugin_baseurl();
        echo '<link rel="stylesheet" type="text/css" href="' . $baseurl . '/styles.css" />';
        return $contributions;
    }

    // TODO think about whether you need to override the is_manual_graded or
    // is_usable_by_random methods form the base class. Most the the time you
    // Won't need to.

    /**
     * @return boolean to indicate success of failure.
     */
    function get_question_options(&$question) {
      	global $DB, $OUTPUT, $COURSE, $CFG;
        
        // TODO code to retrieve the extra data you stored in the database into
        // $question->options.
        $this->loger('get_question_options - START');
		
        //get question context
        $contextid = get_field('question_categories', 'contextid', 'id', $question->category); 
        $context = get_context_instance_by_id($contextid);
//        $context = $this->get_context_by_category_id($question->category);
        //get file from files area
//        $fs = get_file_storage();
//        $files = $fs->get_area_files($context->id, 'qtype_mbimage', 'question', $question->id);
//
//        foreach ($files as $file) {
//        $targetfile = $file;
//        }
        $question_dir = $CFG->dataroot . '/question/' . $COURSE->id . '/' . $question->id . '/';
        $question_filename = $question_dir . $question->id;
        $content = $this->get_file_content($question_filename);        
        
        //create DOM structure from xml
//        $xml = simplexml_load_string($targetfile->get_content());
        $xml = simplexml_load_string($content);
        $json = json_encode($xml);
        $array = json_decode($json,TRUE);  
        //file parse
        $image_options = new stdClass();

        $image_options->imagetype = $array['imagetype'];

        $attr = $xml->image[0]->attributes();
        $filename = $attr['name'];
//        $image_options->imageurl = "@@PLUGINFILE@@/{$filename}";
        $image_options->imagefilename = $filename;

        if($image_options->imagetype == 'selectarea'){

                $image_options->centerpoint->x = $array['selectarea']['centerpoint']['x'];
                $image_options->centerpoint->y = $array['selectarea']['centerpoint']['y'];
                $image_options->width = $array['selectarea']['dimensions']['width'];
                $image_options->height = $array['selectarea']['dimensions']['height'];

        }else if($image_options->imagetype == 'pick'){
                $image_options->singleselect = $array['pick']['singleselect'];
                $answers = array();
                foreach($array['pick']['answers']['answer'] as $key => $a){
                        $answers[$key]->shape = $a['shape'];
                        $answers[$key]->correct = $a['correct'];
                        $answers[$key]->code = $a['code'];
                        $answers[$key]->description = $a['description'];
                        $coords = array();
                        foreach($a['coords']['p'] as $k => $p){					
                                $coords[$k] = $p;
                        }
                        $answers[$key]->coords = $coords;		
                }
                $image_options->answers=$answers;
        }
        $question->options->image = $image_options;

        $this->loger('get_question_options - END');
        return true;
    }

    /**
     * Save the units and the answers associated with this question.
     * @return boolean to indicate success of failure.
     */
    function save_question_options($question) {
        global $CFG,$COURSE,$DB;

        // TODO code to save the extra data to your database tables from the
        // $question object, which has all the post data from editquestion.html
        $this->loger('save_question_options - START');
        $context = $question->context;
       	//erase file (edit mode)
        $this->delete_question($question->id ,$context->id);

        //set up attibuttes which is needed for file saving		
        $save_file['text']="";
        $save_file['format']= FORMAT_HTML;
        $save_file['itemid']= $question->xmlfile;

        //save file
        $this->import_or_save_files($save_file, $context, 'qtype_it4kt_image', 'question', $question->id);        

        //saving image to files area (transform image only once)
//        $fs = get_file_storage();
//        $files = $fs->get_area_files($context->id, 'qtype_mbimage', 'question', $question->id);
//
//        foreach ($files as $file) {
//        $targetfile = $file;
//        }
        //create DOM structure from file
//        $xml = simplexml_load_string($targetfile->get_content());
        $question_filename = $CFG->dataroot . '/question/' . $COURSE->id . '/' . $question->id . '/'. $question->id;
        $content = $this->get_file_content($question_filename);
        $xml = simplexml_load_string($content);        
        
        $json = json_encode($xml);
        $array = json_decode($json,TRUE);  
        //get attribute from xml        
        $attr = $xml->image[0]->attributes();
        $this->create_image_from_base64($context->id,'qtype_it4kt_image','image',$question->id,$attr['name'],$attr['encoding'],$array['image']);
        	
        $this->loger('save_question_options - END');
        return true;
    }

    /**
     * Deletes question from the question-type specific tables
     *
     * @param integer $questionid The question being deleted
     * @return boolean to indicate success of failure.
     */
    function delete_question($questionid) {
        global $CFG, $COURSE;

        // TODO delete any
        $this->loger('delete_question - START');

        //Odstranenie otazky aj so zalohou obrazkov
        $questiondir = $CFG->dataroot . '/question/' . $COURSE->id . '/'. $questionid;
        fulldelete($questiondir);

        //Odstranenie obrazkov z www cesty
        $questiondir = $CFG->dirroot . '/pix/question/' . $COURSE->id . '/' . $questionid . '/';
        fulldelete($questiondir);
        
        $this->loger('delete_question - END');
        return true;        
    }

    function create_session_and_responses(&$question, &$state, $cmoptions, $attempt) {
        global $DB, $OUTPUT;
        
        // TODO create a blank repsonse in the $state->responses array, which
        // represents the situation before the student has made a response.
        $this->loger('create_session_and_responses - START');
        
	// Place the questions into the state options keyed by code
    	if($question->options->image->imagetype == 'pick'){
            $answers = array();
            foreach ($question->options->image->answers as $answer) {
                $answers[$answer->code] = $answer;        
            }
            $state->options->image->answers = $answers;
	}
	$state->responses = array();
        
        $this->loger('create_session_and_responses - END');
        return true;
    }

    function restore_session_and_responses(&$question, &$state) {
        // TODO unpack $state->responses[''], which has just been loaded from the
        // database field question_states.answer into the $state->responses array.
        $this->loger('restore_session_and_responses - START');		
		
    	if($question->options->image->imagetype == 'pick'){
			// Place the questions into the state options keyed by code
			$answers = array();
			foreach ($question->options->image->answers as $answer) {
				$answers[$answer->code] = $answer;        
			}
			$state->options->image->answers = $answers;
			
			if(!empty($state->responses[''])){
				$state->responses = explode(',', $state->responses['']);	
                                
                                $totalgrade = 0;
                                $sumgrade = 0;
                                foreach($question->options->image->answers as $answer){
                                    if($answer->correct == 1){
                                        $totalgrade++;	
                                    }
                                }
                                foreach($state->responses as $response){
                                    $sumgrade += $state->options->image->answers[$response]->correct;
                                }
                                
                                $state->options->correctanswer = ($sumgrade/$totalgrade) == 1 ;
			} else{
				$state->responses = array();
				$state->options->correctanswer = 0;
				$state->options->correctposition = 0;
			}
		}else if ($question->options->image->imagetype == 'selectarea'){
			if(!empty($state->responses[''])){
				$state->responses = explode(',', $state->responses['']);
				$x1 = $state->responses[0];
				$y1 = $state->responses[1];
				$x2 = $state->responses[2];
				$y2 = $state->responses[3];
				
				$x = $question->options->image->centerpoint->x;
				$y = $question->options->image->centerpoint->y;
				
				if( $x > $x1 && $x < $x2 && $y > $y1 && $y < $y2){						
					$state->options->correctposition = 1;	
				}else {
					$state->options->correctposition = 0;
				}	
			} else{
				$state->responses = array();
				$state->options->correctposition = 0;
			}		
		}

        $this->loger('restore_session_and_responses - END');
        return true;
    }

    function save_session_and_responses(&$question, &$state) {
        // TODO package up the students response from the $state->responses
        // array into a string and save it in the question_states.answer field.
        $responses = '';

        $this->loger('save_session_and_responses - START');
        //ukladanie hodnot do databazy napr. 45,23,34,21 jednotlive hodnoty su pozicie v obrazku
        $responses  = implode(',', $state->responses);
		
//        set_field('question_states', 'answer', $responses, array('id' => $state->id));
        set_field('question_states', 'answer', $responses, 'id', $state->id);
        
        $this->loger('save_session_and_responses - END');
    }

    function print_question_formulation_and_controls(&$question, &$state, $cmoptions, $options) {
        global $CFG;
        $this->loger('print_question_formulation_and_controls - START');

        $contextid = get_field('question_categories', 'contextid', 'id', $question->category); 
        $context = get_context_instance_by_id($contextid);
//        $context = $this->get_context_by_category_id($question->category);

        $responses    = $state->responses;
        
	// Print formulation
        $questiontext = $this->format_text($question->questiontext, $question->questiontextformat, $cmoptions);
				
	$a = new stdClass;
        $a->class = '';
        $a->feedbackimg = '';
		
//	$a->imageurl = quiz_rewrite_question_urls($question->options->image->imageurl, 'pluginfile.php', $context->id, 'qtype_mbimage', 'image', array($state->attempt, $state->question), $question->id);
	$a->imageurl = $this->get_image_url($question->id, $question->options->image->imagefilename);
        		
	if($question->options->image->imagetype == 'selectarea'){
		
            //jquery generation
            $a->imgselectarea = $this->selectAreaJQuery($question->options->image->width, $question->options->image->height, $state->responses);	
            // Print the control			   
            $a->control = $this->controlInputs($question, $state->responses);
	
            if (($options->feedback) || $options->correct_responses) {
                $a->feedbackimg = question_get_feedback_image($state->options->correctposition, $options->feedback);
            }
         
            $anss = clone($a);
			
            include("$CFG->dirroot/question/type/it4kt_image/display_selectarea.html");
			
	}else if($question->options->image->imagetype == 'pick'){
            //single select
            $singleselect = $question->options->image->singleselect;
            $onMouseClick="function(data){}";
            if($singleselect == 'true'){
                $onMouseClick = 'function(data){
                    $statelist.find(\'input:checkbox\').each(function(index) {
                        $(this).removeAttr(\'checked\');
                    });
									
		}';	
            }
            
            //imageurl
            $image = $question->options->image;
			
            $map = "";
            $aid=0;
            $areatext = "";	
            foreach($image->answers as $key => $ans){								
                $code = $ans->code;
		$shape = $ans->shape;
				
		//set coordinates of shape
		$coords = "";
		foreach($ans->coords as $coord){
                    $coords = $coords."$coord ,";			
		}	
                $coords = substr_replace($coords, "", strrpos($coords, ","), strlen(","));
		$name = $question->name_prefix . $key;				
		$map = $map."<area code=\"$code\" name=\"{$name}\" shape=\"$shape\"  coords=\"$coords\" href=\"#\" >";
		//description for actual answer
		if(!empty($ans->description))
                    $areatext = $areatext.'{ key: "'.$name.'", toolTip: "'.$ans->description.'"},';
                    //select answer
                    foreach($responses as $response){			
                        if($response == $code){
                            $areatext = $areatext.'{ key: "'.$name.'", selected: true },';	
                    }
                } 		
            }
                
            //description all answers
            $a->areatext = $areatext;
            //create map
            $mapname = "map_{$question->id}";			
            $a->map = "<div>
                        <map id=\"$mapname\" name=\"$mapname\">
                            $map
                        </map>
                       </div>";

            if (($options->feedback) || $options->correctposition) {
                $a->feedbackimg = question_get_feedback_image($state->options->correctanswer, $options->feedback);
            }
            $anss = clone($a);

            include("$CFG->dirroot/question/type/it4kt_image/display_pick.html");
        }  
            
        $this->loger('print_question_formulation_and_controls - END');
    }

    /**
    * JQuery generation - this function generate jquery for select area type.  
    */
    function selectAreaJQuery( $imagewidth , $imageheight , $responses){
        if(count($responses) == 4){
            $jquery_str =  "{
                minHeight: {$imageheight},
		minWidth: {$imagewidth},
		maxHeight: {$imageheight},
		maxWidth: {$imagewidth}, 
		x1:{$responses[0]}, 
		y1:{$responses[1]},
		x2:{$responses[2]},
		y2:{$responses[3]},
		resizable : false, 
		fadeSpeed: 200, 
		onSelectChange: change							
            }";
        }else{
            $jquery_str =  "{
                minHeight: {$imageheight},
		minWidth: {$imagewidth},
		maxHeight: {$imageheight},
		maxWidth: {$imagewidth}, 
		resizable : false, 
		fadeSpeed: 200, 
		onSelectChange: change
            }";
        }
        
        return $jquery_str;
    }
	
    /**
    * Control imputs - generate html inputs for select area type.  
    */
    function controlInputs($question , $responses){
        if(count($responses) == 4){
            $controlinputs = "<input type=\"hidden\" id=\"x0_{$question->id}\"  name=\"{$question->name_prefix}0\" value=\"{$responses[0]}\"/>"
                ."<input type=\"hidden\" id=\"x1_{$question->id}\"  name=\"{$question->name_prefix}1\" value=\"{$responses[1]}\"/>"
		."<input type=\"hidden\" id=\"x2_{$question->id}\"  name=\"{$question->name_prefix}2\" value=\"{$responses[2]}\"/>"
		."<input type=\"hidden\" id=\"x3_{$question->id}\"  name=\"{$question->name_prefix}3\" value=\"{$responses[3]}\"/>";
        }else{
            $controlinputs = "<input type=\"hidden\" id=\"x0_{$question->id}\"  name=\"{$question->name_prefix}0\" />"
                ."<input type=\"hidden\" id=\"x1_{$question->id}\"  name=\"{$question->name_prefix}1\" />"
		."<input type=\"hidden\" id=\"x2_{$question->id}\"  name=\"{$question->name_prefix}2\" />"
		."<input type=\"hidden\" id=\"x3_{$question->id}\"  name=\"{$question->name_prefix}3\" />";
        }
        
        return $controlinputs;
    }
	    
    function grade_responses(&$question, &$state, $cmoptions) {
        // TODO assign a grade to the response in state.
        $this->loger('grade_responses - START');
        $responses = $state->responses;
        $state->raw_grade = 0;
		
        if($question->options->image->imagetype == 'selectarea'){
            if(!empty($responses[0])){
                $x1 = $responses[0];
		$y1 = $responses[1];
		$x2 = $responses[2];
		$y2 = $responses[3];
					
		$x = $question->options->image->centerpoint->x;
		$y = $question->options->image->centerpoint->y;
					
		if( $x > $x1 && $x < $x2 && $y > $y1 && $y < $y2){						
                    $state->raw_grade = 1;					
                    $state->options->correctposition = 1;	
		}else {
                    $state->raw_grade = 0;						
                    $state->options->correctposition = 0;
		}	
            }
	}else if($question->options->image->imagetype == 'pick'){
            $totalgrade = 0;
            $sumgrade = 0;
            foreach($question->options->image->answers as $answer){
                if($answer->correct == 1){
                    $totalgrade++;	
		}
            }
            foreach($responses as $response){
                $sumgrade += $state->options->image->answers[$response]->correct;
            }
            if($totalgrade != 0){
                $state->raw_grade = $sumgrade/$totalgrade;
                $state->options->correctanswer = $state->raw_grade == 1;	
            }else{
                $state->raw_grade = 0;	
                $state->options->correctanswer = 1;	
            }
        }
        // Make sure we don't assign negative or too high marks
        $state->raw_grade = min(max((float) $state->raw_grade, 0.0), 1.0) * $question->maxgrade;

        // Apply the penalty for this attempt
        $state->penalty = $question->penalty * $question->maxgrade;

        // mark the state as graded
        $state->event = ($state->event ==  QUESTION_EVENTCLOSE) ? QUESTION_EVENTCLOSEANDGRADE : QUESTION_EVENTGRADE;
		
        $this->loger('grade_responses - END');
        
        return true;
    }

    function compare_responses($question, $state, $teststate) {
        // TODO write the code to return two different student responses, and
        // return two if the should be considered the same.
        $this->loger('compare_responses - START');
        //image pick - control if count of response is same (count of response change on select)
        if(!empty($state->responses) && !empty($teststate->responses)){
            if(sizeof($state->responses) != sizeof($teststate->responses)){
                $this->loger('compare_responses - END - false - odlisny pocet odpovedi');
                return false;
            }
        }
        foreach ($state->responses as $key=>$sr) {
            if (empty($teststate->responses[$key])) {
                if (!empty($state->responses[$key])) {
                    $this->loger('compare_responses - END - false - odpoved v teste nie je oznacena');
                    return false;
                }
            } else if ($state->responses[$key] != $teststate->responses[$key]) {
                $this->loger('compare_responses - END - false - spravna odpoved nie je oznacena, alebo je ina');
                return false;
           }
        }        
        $this->loger('compare_responses - END - true');
        
        return true;
    }

    /**
     * Checks whether a response matches a given answer, taking the tolerance
     * and units into account. Returns a true for if a response matches the
     * answer, false if it doesn't.
     */
    function test_response(&$question, &$state, $answer) {
        // TODO if your code uses the question_answer table, write a method to
        // determine whether the student's response in $state matches the
        // answer in $answer.
        $this->loger('test_response - START');

        $this->loger('test_response - END');
        return false;
    }

    function check_response(&$question, &$state){
        // TODO
        $this->loger('check_response - START');

        $this->loger('check_response - END');
        return false;
    }

    function get_correct_responses(&$question, &$state) {
        // TODO
        $this->loger('get_correct_responses - START');

        $responses = array();
        if($question->options->image->imagetype == 'selectarea'){
            $x = $question->options->image->centerpoint->x;
            $y = $question->options->image->centerpoint->y;
            $width = $question->options->image->width;
            $height = $question->options->image->height;

            $responses[0] = $x - ($width/2);
            $responses[1] = $y - ($height/2);
            $responses[2] = $x + ($width/2);
            $responses[3] = $y + ($height/2);
            $state->options->correctposition = 1;
        }else{
            $i = 0;
            foreach($question->options->image->answers as $answer){
                if($answer->correct == 1){
                    $responses[$i] = $answer->code;
                    $i++;	
                }	
            }	
        }
        
        $this->loger('get_correct_responses - END');
        
        return empty($responses) ? null : $responses;  
    }

    function get_all_responses(&$question, &$state) {
        $result = new stdClass;
        // TODO

        $this->loger('get_all_responses - START');

        $this->loger('get_all_responses - END');
        return $result;
    }

    function get_actual_response($question, $state) {
        // TODO
        //$responses = '';        
        $this->loger('get_actual_response - START');
        
        $responses = array();
        if (!empty($state->responses)) {
            foreach ($state->responses as $aid =>$rid){
                $responses[] = $rid;
            }
        } else {
            $responses[] = '';
        }

        $this->loger('get_actual_response - END');
        return $responses;
    }

    /**
     * Backup the data in the question
     *
     * This is used in question/backuplib.php
     */
    function backup($bf,$preferences,$question,$level=6) {
        $status = true;

        // TODO write code to backup an instance of your question type.
        $this->loger('backup - START');

        $this->loger('backup - END');

        return $status;
    }

    /**
     * Restores the data in the question
     *
     * This is used in question/restorelib.php
     */
    function restore($old_question_id,$new_question_id,$info,$restore) {
        $status = true;

        // TODO write code to restore an instance of your question type.
        $this->loger('restore - START');

        $this->loger('restore - END');

        return $status;
    }


	/**
     * Imports question from the Moodle XML format
     *
     * Imports question using information from extra_question_fields function
     * If some of you fields contains id's you'll need to reimplement this
     */
    function import_from_xml($data, $question, $format, $extra=null) {
        $this->loger('import_from_xml - START');
        if (!array_key_exists('@', $data)) {
            $this->loger('import_from_xml - END - FALSE');
            return false;
        }
        if (!array_key_exists('type', $data['@'])) {
            $this->loger('import_from_xml - END - FALSE');
            return false;
        }
        if ($data['@']['type'] == 'it4kt_image') {
            $question = $format->import_headers($data);

            // header parts particular to ordering
            $question->qtype = $this->name();

            // get file
            $filexml = $format->getpath($data, array('#', 'file'), array());
            $question->xmlfile = $this->import_files_to_draft_file_area($format, $filexml); //ulozim meno suboru

            $this->loger('import_from_xml - END - TRUE');
            return $question;
        }

        $this->loger('import_from_xml - END - FALSE');
        return false;
    }

    /**
     * Export question to the Moodle XML format
     *
     * Export question using information from extra_question_fields function
     * If some of you fields contains id's you'll need to reimplement this
     */
    function export_to_xml($question, $format, $extra) {
        $this->loger('export_to_xml - START');

        $expout = '';
        $files = get_area_files($question->id);

        $expout .= $format->write_files($files);

        $this->loger('export_to_xml - END');
        return $expout;
    }

    /************************************************************************/
    /********************** Pridane pomocne funkcie *************************/
    /************************************************************************/
    function create_image_from_base64($contextid,$component,$filearea,$itemid,$filename,$encoding,$content){
        global $COURSE, $CFG;
        
        $this->loger('create_image_from_base64: START');
        
//	global $DB;
//	$record = new stdClass();
//        $record->contextid = $contextid;
//        $record->component = $component;
//        $record->filearea = $filearea;
//        $record->itemid = $itemid;
//        $record->filename = $filename;
//        $record->filepath = '/';
	$file->encoding = $encoding;
	$file->content = $content;
//
//        $fs = get_file_storage();                
//        $fs->create_file_from_string($record, $this->decode_file($file));

        
        //Idem ukladat obrazky aj do adresara aby bol v ceste pre web
        $questiondir = $CFG->dirroot . '/pix/question/' . $COURSE->id . '/' . $itemid . '/';
        $filename =  $questiondir . $filename;
        $this->save_file($filename, $this->decode_file($file));
        
        //Ulozenie ako zaloha do adresara s otazkou
        $questiondir = $CFG->dataroot . '/question/' . $COURSE->id . '/' . $itemid . '/';
        $filename =  $questiondir . $filename;
        $this->save_file($filename, $this->decode_file($file));
        
        $this->loger('create_image_from_base64: END');
	return true;
    }    
    
    /**
     * Create a draft files area, import files into it and return the draft item id.
     * @param qformat_xml $format
     * @param array $xml an array of <file> nodes from the the parsed XML.
     * @return integer draftitemid
     */
    function import_files_to_draft_file_area($format, $files) {
        global $CFG,$COURSE,$USER;
        $this->loger('import_files_to_draft_file_area: START');
        foreach ($files as $file) {

            $filename = $file['@']['name'];

            $questiondir = $CFG->dataroot . '/question/' . $COURSE->id . '/'. $USER->id . '/draft/' . $filename;
            $xmlfile->encoding = $file['@']['encoding'];
            $xmlfile->content = $file['#'];
            $content = $this->decode_file($xmlfile);
            //Ulozenie suboru
            $this->save_file($questiondir, $content);
        }

        $this->loger('import_files_to_draft_file_area: END');
        return $filename;
    }


    /**
     * Loads directory of files for question type identified by question ID.
     */
    function get_area_files($questionid) {
        global $CFG,$COURSE;
        $this->loger('get_area_files - START');
        $questiondir = $CFG->dataroot . '/question/' . $COURSE->id . '/' . $questionid;

        $questiondir1 = make_upload_directory($questiondir);
        $this->loger('get_area_files - END - reading directory from: \'' . $questiondir1 . '\'');
        return get_directory_list($questiondir1);
    }

    /**
     * Save the file belonging to one text field.
     *
     * @param array $field the data from the form (or from import). This will
     *      normally have come from the formslib editor element, so it will be an
     *      array with keys 'text', 'format' and 'itemid'. However, when we are
     *      importing, it will be an array with keys 'text', 'format' and 'files'
     * @param object $context the context the question is in.
     * @param string $component indentifies the file area question.
     * @param string $filearea indentifies the file area questiontext, generalfeedback,answerfeedback.
     * @param integer $itemid identifies the file area.
     *
     * @return string the text for this field, after files have been processed.
     */
    function import_or_save_files($field, $context, $component, $filearea, $itemid) {
        global $CFG,$COURSE, $USER;
        if (!empty($field['itemid'])) {
            // This is the normal case. We are safing the questions editing form.

            //Nacitanie obsahu suboru z draft oblasti
            $questiondir_draft = $CFG->dataroot . '/question/' . $COURSE->id . '/'. $USER->id . '/draft/';
            $filename_draft =  $questiondir_draft . $field['itemid'];
            $this->loger('import_or_save_files: saving question from editing form from file \'' . $filename_draft . '\'');
            $content = $this->get_file_content($filename_draft);
            $this->loger('import_or_save_files: saving question from editing form from file \'' . $filename_draft . '\'');

            //Ulozenie suboru
            $questiondir = $CFG->dataroot . '/question/' . $COURSE->id . '/' . $itemid . '/';
            $filename =  $questiondir . $itemid;
            $this->save_file($filename, $content);
        } else if (!empty($field['files'])) {
            $this->loger('import_or_save_files: saving question from import');
        // This is the case when we are doing an import.
            foreach ($field['files'] as $file) {
                $this->import_file($context, $component,  $filearea, $itemid, $file);
            }
        }

        $this->loger('import_or_save_files: return text \'' . trim($field['text']) .'\'');
        return trim($field['text']);
    }

    function import_file($context, $component, $filearea, $itemid, $file) {
       global $COURSE;
        $questiondir = $CFG->dataroot . '/question/' . $COURSE->id . '/' .  $itemid . '/' . $itemid;
        $file1 = fopen($questiondir, "w");
        fwrite($file1, $this->decode_file($file));
        fclose($file1);
    }

    /**
     * Save file.
     *
     * @param $filename is full path including file name
     * @param $content id file content
     */
    function save_file($filename, $content)
    {
        $this->loger('save_file: saving file \'' . $filename .'\'' );
        $dirname = dirname($filename);
        if (!is_dir($dirname))
        {
            mkdir($dirname, 0777, true);
        }

        $file = fopen($filename, "w");
        fwrite($file, $content);
        fclose($file);
    }

    /**
     * Logger.
     *
     * @param $filename is full path including file name
     * @param $content id file content
     */
    function loger($log)
    {
        global $CFG;

        $logfile = $CFG->dataroot . '/log/' . $this->name(). '.txt';
        $dirname = dirname($logfile);
        if (!is_dir($dirname))
        {
            mkdir($dirname, 0777, true);
        }

        $file = fopen($logfile, "a");
        fwrite($file, date("d.m.Y H:i:s", time()) . ': ' . $log . "\n");
        fclose($file);
    }

    /**
     * Save file.
     *
     * @param $filename is full path including file name
     * @param $content id file content
     */
    function get_file_content($filename)
    {
        //return file_get_contents($filename);
        $this->loger('get_file_content: Read from file \'' . $filename . '\'');

        $file = fopen($filename, "r");
        $this->loger('get_file_content: fopen with filesize: ' . filesize($filename));
        $content = fread($file, filesize($filename));
        $this->loger('get_file_content: fread');
        fclose($file);

        return $content;
    }

    function decode_file($file) {
        switch ($file->encoding) {
        case 'base64': return base64_decode($file->content);
        default:
            return $file->content;
        }
    }
    
    
    function get_image_url($questionid, $answerimagefilename) {
        global $CFG,$COURSE;

        $baseurl = $CFG->wwwroot . '/pix/question/' . "$COURSE->id/$questionid/$answerimagefilename";

        if ($options['forcehttps']) {
            $baseurl = str_replace('http://', 'https://', $baseurl);
        }

        return $baseurl;
    }        
    /************************************************************************/

}

// Register this question type with the system.
question_register_questiontype(new it4kt_image_qtype());
?>
