<?php
/**
 * The question type class for the Match question type.
 *
 * @copyright &copy; 2012 Peter Vaclavik
 * @author peter.vaclavik@tuke.sk
 * @license http://www.gnu.org/copyleft/gpl.html GNU Public License
 * @package it4kt
 *//** */

/**
 * The Match question class
 *
 * TODO give an overview of how the class works here.
 */
class it4kt_match_qtype extends default_questiontype {

    function name() { 
        return 'it4kt_match';
    }

	/**
     * Allow question types to include required JavaScrip or CSS on pages
     * where they are going to be printed.
     *
     * @param object $question The question object.
     * @param object $state    The state object.
     */
    function get_html_head_contributions(&$question, &$state) {
        global $CFG;
        if (file_exists($CFG->dirroot . '/lib/js/jquery-1.7.1.js')) {
            require_js($CFG->wwwroot . '/lib/js/jquery-1.7.1.js');
        }
        if (file_exists($CFG->dirroot . '/lib/js/ui/jquery.ui.core.js')) {
            require_js($CFG->wwwroot . '/lib/js/ui/jquery.ui.core.js');
        }
        if (file_exists($CFG->dirroot . '/lib/js/ui/jquery.ui.widget.js')) {
            require_js($CFG->wwwroot . '/lib/js/ui/jquery.ui.widget.js');
        }
        if (file_exists($CFG->dirroot . '/lib/js/ui/jquery.ui.mouse.js')) {
            require_js($CFG->wwwroot . '/lib/js/ui/jquery.ui.mouse.js');
        }
        if (file_exists($CFG->dirroot . '/lib/js/ui/jquery.ui.position.js')) {
            require_js($CFG->wwwroot . '/lib/js/ui/jquery.ui.position.js');
        }
        if (file_exists($CFG->dirroot . '/lib/js/ui/jquery.ui.draggable.js')) {
            require_js($CFG->wwwroot . '/lib/js/ui/jquery.ui.draggable.js');
        }
        if (file_exists($CFG->dirroot . '/lib/js/ui/jquery.ui.droppable.js')) {
            require_js($CFG->wwwroot . '/lib/js/ui/jquery.ui.droppable.js');
        }
        if (file_exists($CFG->dirroot . '/lib/js/ui/jquery.ui.resizable.js')) {
            require_js($CFG->wwwroot . '/lib/js/ui/jquery.ui.resizable.js');
        }
        if (file_exists($CFG->dirroot . '/lib/js/ui/jquery.ui.dialog.js')) {
            require_js($CFG->wwwroot . '/lib/js/ui/jquery.ui.dialog.js');
        }

        $contributions = parent::get_html_head_contributions($question, $state);

        $baseurl = $this->plugin_baseurl();
        echo '<link rel="stylesheet" type="text/css" href="' . $baseurl . '/styles.css" />';
        return $contributions;
    }
    
    // TODO think about whether you need to override the is_manual_graded or
    // is_usable_by_random methods form the base class. Most the the time you
    // Won't need to.

    /**
     * @return boolean to indicate success of failure.
     */
    function get_question_options(&$question) {
      	global $DB, $OUTPUT, $COURSE, $CFG;
        
        // TODO code to retrieve the extra data you stored in the database into
        // $question->options.
        $this->loger('get_question_options - START');
        
		
        //get context of the question
        $contextid = get_field('question_categories', 'contextid', 'id', $question->category); 
        $context = get_context_instance_by_id($contextid);
//		$context = $this->get_context_by_category_id($question->category);
		//get file from file storage
//        $fs = get_file_storage();
//        $files = $fs->get_area_files($context->id, 'qtype_mbmatch', 'question', $question->id);
//
//        foreach ($files as $file) {
//        $targetfile = $file;
//        }
        $question_dir = $CFG->dataroot . '/question/' . $COURSE->id . '/' . $question->id . '/';
        $question_filename = $question_dir . $question->id;
        $content = $this->get_file_content($question_filename);
        
        //create DOM structure from xml
//        $xml = simplexml_load_string($targetfile->get_content());
        $xml = simplexml_load_string($content);
        
        $json = json_encode($xml);
        $array = json_decode($json,TRUE);     

        //file parsing
        $mbmatchoptions = new StdClass(); 
        $answers = array();
        $subquestions = array();
        $j = 0;
        foreach($array['answers']['answer'] as $key => $a){
                if(!empty($a['subquestion'])){
                        $subquestions[$j]->subquestion = $a['subquestion'];
                        $subquestions[$j]->code = $a['code'];
                        $j++;
                }
                if(empty($a['answertext'])){
                        $attr = $xml->answers->answer[$key]->answerimage[0]->attributes();
                        $filename = $attr['name'];
                        $answers[$key]->answerimage = $question_dir . $filename;
                        $answers[$key]->answerimagefilename = $filename;
//                        $answers[$key]->answerimage = "@@PLUGINFILE@@/{$filename}";
                }else{
                        $answers[$key]->answertext = $a['answertext'];
                }
                $answers[$key]->code = $a['code'];			
        }
        $mbmatchoptions->subquestions = $subquestions;
        $mbmatchoptions->answers = $answers;    
        $question->options->mbmatch = $mbmatchoptions;
        
        $this->loger('get_question_options - END');
        return true;
    }

    /**
     * Save the units and the answers associated with this question.
     * @return boolean to indicate success of failure.
     */
    function save_question_options($question) {
        // TODO code to save the extra data to your database tables from the
        // $question object, which has all the post data from editquestion.html
        $this->loger('save_question_options - START');

        global $CFG,$COURSE,$DB;
        $context = $question->context;
		//remove file and images if exist(edit mode)
        $this->delete_question($question->id, $context->id);
	//set up attibuttes which is needed for file saving	
	$save_file['text']="$question->xmlfile";
	$save_file['format']= FORMAT_HTML;
	$save_file['itemid']= $question->xmlfile;
	//save file
	$this->import_or_save_files($save_file, $context, 'qtype_it4kt_match', 'question', $question->id);
		
	//saving image to files area (transform image only once)
//	$fs = get_file_storage();
//	$files = $fs->get_area_files($context->id, 'qtype_mbmatch', 'question', $question->id);
//		
//	foreach ($files as $file) {
//            $targetfile = $file;
//	}
		
//	$xml = simplexml_load_string($targetfile->get_content());
        $question_filename = $CFG->dataroot . '/question/' . $COURSE->id . '/' . $question->id . '/'. $question->id;
        $content = $this->get_file_content($question_filename);
        $xml = simplexml_load_string($content);
        
	$json = json_encode($xml);
	$array = json_decode($json,TRUE);  
		
	foreach($array['answers']['answer'] as $key => $a){
            if(empty($a['answertext'])){
		$attr = $xml->answers->answer[$key]->answerimage[0]->attributes();                
		$this->create_image_from_base64($context->id,'qtype_it4kt_match','image',$question->id,$attr['name'],$attr['encoding'],$a['answerimage']);
            }
	}
		
        $this->loger('save_question_options - END');
        return true;
    }

    /**
     * Deletes question from the question-type specific tables
     *
     * @param integer $questionid The question being deleted
     * @return boolean to indicate success of failure.
     */
    function delete_question($questionid) {
        global $CFG, $COURSE;

        // TODO delete any
        $this->loger('delete_question - START');

        //Odstranenie otazky aj so zalohou obrazkov
        $questiondir = $CFG->dataroot . '/question/' . $COURSE->id . '/'. $questionid;
        fulldelete($questiondir);

        //Odstranenie obrazkov z www cesty
        $questiondir = $CFG->dirroot . '/pix/question/' . $COURSE->id . '/' . $questionid . '/';
        fulldelete($questiondir);
        
        $this->loger('delete_question - END');
        return true;
    }

    function create_session_and_responses(&$question, &$state, $cmoptions, $attempt) {
        global $DB, $OUTPUT;
        
        // TODO create a blank repsonse in the $state->responses array, which
        // represents the situation before the student has made a response.
        $this->loger('create_session_and_responses - START');
        
        $state->options->subquestions = $question->options->mbmatch->subquestions;
		
        // Place the answers into the state options keyed by code
        foreach ($question->options->mbmatch->answers as $answer) {
            $state->options->answers[$answer->code] = $answer;        
        }
        foreach ($state->options->answers as $key => $ans) {
            $ans->id = $key;
            $state->options->answers[$key] = clone($ans);	
        }

        // create an array of answerids 
        $answerids = array_values(array_map(create_function('$val','return $val->id;'), $state->options->answers));                
        $state->options->answerids = swapshuffle($answerids);
        $state->responses = array();
                
        $this->loger('create_session_and_responses - END');
        return true;
    }

    function restore_session_and_responses(&$question, &$state) {
        global $DB, $OUTPUT;
        
       // TODO unpack $state->responses[''], which has just been loaded from the
        // database field question_states.answer into the $state->responses array.
        $this->loger('restore_session_and_responses - START');

 	$state->responses = explode(',', $state->responses['']);
				
	$state->options->subquestions = $question->options->mbmatch->subquestions;
	$answers = $question->options->mbmatch->answers;
		
	////answers
	// Place the questions into the state options keyed by code
        foreach ($answers as $answer) {
            $state->options->answers[$answer->code] = $answer;
        }
	foreach ($state->options->answers as $key => $ans) {  
            $ans->id       		= $key;			
            $state->options->answers[$key] = clone($ans);
        }
		
	$answerids = array_values(array_map(create_function('$val','return $val->id;'), $state->options->answers));
	$state->options->answerids = swapshuffle($answerids);
	////subquestions
	foreach ($state->options->subquestions as $key => $sub) {	
            if(!empty($state->options->subquestions[$key])){
                $state->options->correctposition[$key] = 0;
            }
	}
		
	foreach ($state->responses as $key => $response) {	
            if(!empty($state->options->subquestions[$key])){
                if($state->options->subquestions[$key]->code == $response){			
                    $state->options->correctposition[$key] = 1;	
		}else if ($state->options->subquestions[$key]->code != $response){
                    $state->options->correctposition[$key] = 0;
		}	
            }
	}
		        
        $this->loger('restore_session_and_responses - END');
        
        return true;
    }

    function save_session_and_responses(&$question, &$state) {
        // TODO package up the students response from the $state->responses
        // array into a string and save it in the question_states.answer field.
        $responses = '';

        $this->loger('save_session_and_responses - START');
        
        $responses  = implode(',', $state->responses);		
        set_field('question_states', 'answer', $responses, 'id', $state->id);
        
        $this->loger('save_session_and_responses - END');
        
        return true;
    }

    function print_question_formulation_and_controls(&$question, &$state, $cmoptions, $options) {
        global $CFG;
        $this->loger('print_question_formulation_and_controls - START');

        $contextid = get_field('question_categories', 'contextid', 'id', $question->category); 
        $context = get_context_instance_by_id($contextid);
//        $context = $this->get_context_by_category_id($question->category);
        
        $answers = $state->options->answers;
		
        //print question text
        $questiontext = $this->format_text($question->questiontext,$question->questiontextformat, $cmoptions);
		
        //prepare variables for jquery generation
        $all_subquestion_ids =''; $variables = '';
        foreach ($state->options->subquestions as $key => $subquestion) {
            $all_subquestion_ids = $all_subquestion_ids.'#'."$question->name_prefix{$key}".' li ,';
            $variables= $variables.'$'."$question->name_prefix{$key}"." = $( \"#"."$question->name_prefix{$key}"."\" )".",";
        }
		
        $code = '';
        foreach ($state->options->subquestions as $key => $subquestion) {
            if(!empty($subquestion)){
                $s = new stdClass;
            	$s->class = '';
            	$s->feedbackimg = '';
			
                $name = "name=\"{$question->name_prefix}{$key}\"";
                $id = "$question->name_prefix{$key}";
            
                // Print the control
                $s->idname = $id;
									
                $s->control = "<input type=\"hidden\" id=\"$id\" $name />";
                $s->text = $subquestion->subquestion;
                $s->response = '';
			
                if (($options->feedback) || $options->correct_responses) {
                    $s->feedbackimg = question_get_feedback_image($state->options->correctposition[$key], $options->feedback);
                }
				
                //erase current subquestion
                $selected_ids = str_replace("#{$id} li ,","",$all_subquestion_ids);
                $selected_ids = substr($selected_ids,0,-1);
                //jquery code generation (for each subquestion)
                $code = $code
                .'// let the subquestion be droppable, accepting the gallery items
                $'."{$id}.droppable({
                        accept: \"#gallery_{$question->id} > li , {$selected_ids}\",
                        activeClass: \"ui-state-highlight\",
                        drop: function( event, ui ) {
                                deleteImage( ui.draggable , ".'$'."{$id} );
                        }
                }); 
                // let the gallery items be draggable
                $( \"li\",".' $'."{$id} ).draggable({
                        revert: \"invalid\", // when not dropped, the item will revert back to its initial position
                        helper: \"clone\",
                        cursor: \"move\"
                });";	

                //set student's answer
                if(!empty($state->responses)){
                    if(!empty($state->responses[$key])){
                        $response = $state->responses[$key];
                        $s->control = "<input type=\"hidden\" id=\"$id\" $name value=\"$response\"/>";
                        $answer = $state->options->answers[$state->responses[$key]];
                        unset($answers[$state->responses[$key]]);
                        if(!isset($answer->answertext)){
                            //$answerimageurl = quiz_rewrite_question_urls($answer->answerimage, 'pluginfile.php', $context->id, 'qtype_mbmatch', 'image', array($state->attempt, $state->question), $question->id);
                            $imgurl = $this->get_image_url($question->id, $answer->answerimagefilename);
                            $answertextresponse = "<img src=\"$imgurl\" alt=\"\" width=\"96\" height=\"72\" code=\"$answer->code\"/>";
                        }else{
                            $answertextresponse = "<p code=\"$answer->code\">$answer->answertext</p>";
                        }

                        $s->response = '<ul class="gallery ui-helper-reset">
                                            <li class="ui-widget-content ui-corner-tr ui-draggable" style="display: list-item;">
                                                '.$answertextresponse.'
                                            </li>
                                        </ul>';
                        }
                }
                $subq[] = clone($s);
            }
        }   
		
        //erase last ","
        $all_subquestion_ids = substr($all_subquestion_ids,0,-1);
        $variables = substr($variables,0,-1);
        //get jquery together
        $jquerycode = 'var $gallery = $( "#gallery'."_{$question->id}".'" ),'
                              ."$variables;"
                              .$code.	
                                  "// let the gallery be droppable as well, accepting items from subquestions\n"
                                  .'$gallery'.".droppable({
                                                accept: \"{$all_subquestion_ids}\",
                                                activeClass: \"custom-state-active\",
                                                drop: function( event, ui ) {
                                        recycleImage( ui.draggable );
                                        }
                                });";

        //create answers
        $anss = array();
        foreach ($state->options->answerids as $aid) {
            $this->loger('print_question_formulation_and_controls - Answer: '.$aid);
            if(isset($answers[$aid])){
                $this->loger('print_question_formulation_and_controls - Answer is SET');
                $answer = $answers[$aid];
                $a = new stdClass;
            	$a->class = '';
            	$a->feedbackimg = '';
                if(!isset($answer->answertext)){
                    //$answerimageurl = quiz_rewrite_question_urls($answer->answerimage, 'pluginfile.php', $context->id, 'qtype_mbmatch', 'image', array($state->attempt, $state->question), $question->id);
                    $imgurl = $this->get_image_url($question->id, $answer->answerimagefilename);                    
                    $a->answertext = "<img src=\"$imgurl\" alt=\"\" width=\"96\" height=\"72\" code=\"$answer->code\"/>";
                }else{
                    $a->answertext = "<p code=\"$answer->code\">$answer->answertext</p>";
                }
                $anss[] = clone($a);
            }
        }	        
        include("$CFG->dirroot/question/type/it4kt_match/display.html");

        $this->loger('print_question_formulation_and_controls - END');
    }

    function grade_responses(&$question, &$state, $cmoptions) {
        // TODO assign a grade to the response in state.
        $this->loger('grade_responses - START');
        
        $responses = $state->responses;		
	$sumgrade = 0;
        $totalgrade = count($state->options->subquestions);
	foreach ($state->options->subquestions as $key => $sub) {	
            if(!empty($state->options->subquestions[$key])){
                $state->options->correctposition[$key] = 0;
            }
	}	
	foreach ($responses as $key => $response) {	
            if($state->options->subquestions[$key]->code == $response){						
                $sumgrade += 1;					
		$state->options->correctposition[$key] = 1;	
            }else if ($state->options->subquestions[$key]->code != $response){
                $sumgrade += 0;						
                $state->options->correctposition[$key] = 0;
            }		
	}			
			
	$state->raw_grade = $sumgrade/$totalgrade;
        // Make sure we don't assign negative or too high marks
        $state->raw_grade = min(max((float) $state->raw_grade,0.0), 1.0) * $question->maxgrade;

        // Apply the penalty for this attempt
        $state->penalty = $question->penalty * $question->maxgrade;

        // mark the state as graded
        $state->event = ($state->event ==  QUESTION_EVENTCLOSE) ? QUESTION_EVENTCLOSEANDGRADE : QUESTION_EVENTGRADE;
        return true;

        $this->loger('grade_responses - END');
    }


     /**
     * Compares two question states for equivalence of the student's responses
     *
     * @return boolean
     * @param object $question  The question for which the states are to be
     *                          compared. 
     * @param object $state     The state of the question. 
     * @param object $teststate The state whose responses are to be
     *                          compared. 
	 */
    function compare_responses($question, $state, $teststate) {
        // TODO write the code to return two different student responses, and
        // return two if the should be considered the same.
        $this->loger('compare_responses - START');

        foreach ($state->responses as $key=>$sr) {
            if (empty($teststate->responses[$key])) {
                if (!empty($state->responses[$key])) {
                    return false;
                }
            } else if ($state->responses[$key] != $teststate->responses[$key]) {
                return false;
            }
        }
        
        $this->loger('compare_responses - END');
        return true; 
    }

    /**
     * Checks whether a response matches a given answer, taking the tolerance
     * and units into account. Returns a true for if a response matches the
     * answer, false if it doesn't.
     */
    function test_response(&$question, &$state, $answer) {
        // TODO if your code uses the question_answer table, write a method to
        // determine whether the student's response in $state matches the
        // answer in $answer.
        $this->loger('test_response - START');

        $this->loger('test_response - END');
        return false;
    }

    function check_response(&$question, &$state){
        // TODO
        $this->loger('check_response - START');

        $this->loger('check_response - END');
        return false;
    }

    function get_correct_responses(&$question, &$state) {
        // TODO
        $this->loger('get_correct_responses - START');

        $responses = array();
        foreach ($state->options->subquestions as $key => $subquestion) {
            $responses[$key] = (string) $subquestion->code;
	}
        return empty($responses) ? null : $responses;        
        $this->loger('get_correct_responses - END');
        
        return false;
    }

    function get_all_responses(&$question, &$state) {
        $result = new stdClass;
        // TODO

        $this->loger('get_all_responses - START');

        $this->loger('get_all_responses - END');
        return $result;
    }

    function get_actual_response($question, $state) {
        // TODO
        $this->loger('get_actual_response - START');
        
        $responses = array();

        $this->loger('get_actual_response - END');
        return $state->responses;
    }

    /**
     * Backup the data in the question
     *
     * This is used in question/backuplib.php
     */
    function backup($bf,$preferences,$question,$level=6) {
        $status = true;

        // TODO write code to backup an instance of your question type.
        $this->loger('backup - START');

        $this->loger('backup - END');

        return $status;
    }

    /**
     * Restores the data in the question
     *
     * This is used in question/restorelib.php
     */
    function restore($old_question_id,$new_question_id,$info,$restore) {
        $status = true;

        // TODO write code to restore an instance of your question type.
        $this->loger('restore - START');

        $this->loger('restore - END');

        return $status;
    }


	/**
     * Imports question from the Moodle XML format
     *
     * Imports question using information from extra_question_fields function
     * If some of you fields contains id's you'll need to reimplement this
     */
    function import_from_xml($data, $question, $format, $extra=null) {
        $this->loger('import_from_xml - START');
        if (!array_key_exists('@', $data)) {
            $this->loger('import_from_xml - END - FALSE');
            return false;
        }
        if (!array_key_exists('type', $data['@'])) {
            $this->loger('import_from_xml - END - FALSE');
            return false;
        }
        if ($data['@']['type'] == 'it4kt_match') {
            $question = $format->import_headers($data);

            // header parts particular to ordering
            $question->qtype = 'it4kt_match';

            // get file
            $filexml = $format->getpath($data, array('#', 'file'), array());
            $question->xmlfile = $this->import_files_to_draft_file_area($format, $filexml); //ulozim meno suboru

            $this->loger('import_from_xml - END - TRUE');
            return $question;
        }

        $this->loger('import_from_xml - END - FALSE');
        return false;
    }

    /**
     * Export question to the Moodle XML format
     *
     * Export question using information from extra_question_fields function
     * If some of you fields contains id's you'll need to reimplement this
     */
    function export_to_xml($question, $format, $extra) {
        $this->loger('export_to_xml - START');

        $expout = '';
        $files = get_area_files($question->id);

        $expout .= $format->write_files($files);

        $this->loger('export_to_xml - END');
        return $expout;
    }

    /************************************************************************/
    /********************** Pridane pomocne funkcie *************************/
    /************************************************************************/
    /**
     * Create image from base64 string and save it to filesystem
     */
    function create_image_from_base64($contextid,$component,$filearea,$itemid,$filename,$encoding,$content){
        global $COURSE, $CFG;
        
        $this->loger('create_image_from_base64: START');
        
//	global $DB;
//	$record = new stdClass();
//        $record->contextid = $contextid;
//        $record->component = $component;
//        $record->filearea = $filearea;
//        $record->itemid = $itemid;
//        $record->filename = $filename;
//        $record->filepath = '/';
	$file->encoding = $encoding;
	$file->content = $content;
//
//        $fs = get_file_storage();                
//        $fs->create_file_from_string($record, $this->decode_file($file));

        
        //Idem ukladat obrazky aj do adresara aby bol v ceste pre web
        $questiondir = $CFG->dirroot . '/pix/question/' . $COURSE->id . '/' . $itemid . '/';
        $filename =  $questiondir . $filename;
        $this->save_file($filename, $this->decode_file($file));
        
        //Ulozenie ako zaloha do adresara s otazkou
        $questiondir = $CFG->dataroot . '/question/' . $COURSE->id . '/' . $itemid . '/';
        $filename =  $questiondir . $filename;
        $this->save_file($filename, $this->decode_file($file));
        
        $this->loger('create_image_from_base64: END');
	return true;
    }    
    
    /**
     * Create a draft files area, import files into it and return the draft item id.
     * @param qformat_xml $format
     * @param array $xml an array of <file> nodes from the the parsed XML.
     * @return integer draftitemid
     */
    function import_files_to_draft_file_area($format, $files) {
        global $CFG,$COURSE,$USER;
        $this->loger('import_files_to_draft_file_area: START');
        foreach ($files as $file) {

            $filename = $file['@']['name'];

            $questiondir = $CFG->dataroot . '/question/' . $COURSE->id . '/'. $USER->id . '/draft/' . $filename;
            $xmlfile->encoding = $file['@']['encoding'];
            $xmlfile->content = $file['#'];
            $content = $this->decode_file($xmlfile);
            //Ulozenie suboru
            $this->save_file($questiondir, $content);
        }

        $this->loger('import_files_to_draft_file_area: END');
        return $filename;
    }


    /**
     * Loads directory of files for question type identified by question ID.
     */
    function get_area_files($questionid) {
        global $CFG,$COURSE;
        $this->loger('get_area_files - START');
        $questiondir = $CFG->dataroot . '/question/' . $COURSE->id . '/' . $questionid;

        $questiondir1 = make_upload_directory($questiondir);
        $this->loger('get_area_files - END - reading directory from: \'' . $questiondir1 . '\'');
        return get_directory_list($questiondir1);
    }

    /**
     * Save the file belonging to one text field.
     *
     * @param array $field the data from the form (or from import). This will
     *      normally have come from the formslib editor element, so it will be an
     *      array with keys 'text', 'format' and 'itemid'. However, when we are
     *      importing, it will be an array with keys 'text', 'format' and 'files'
     * @param object $context the context the question is in.
     * @param string $component indentifies the file area question.
     * @param string $filearea indentifies the file area questiontext, generalfeedback,answerfeedback.
     * @param integer $itemid identifies the file area.
     *
     * @return string the text for this field, after files have been processed.
     */
    function import_or_save_files($field, $context, $component, $filearea, $itemid) {
        global $CFG,$COURSE, $USER;
        if (!empty($field['itemid'])) {
            // This is the normal case. We are safing the questions editing form.

            //Nacitanie obsahu suboru z draft oblasti
            $questiondir_draft = $CFG->dataroot . '/question/' . $COURSE->id . '/'. $USER->id . '/draft/';
            $filename_draft =  $questiondir_draft . $field['itemid'];
            $this->loger('import_or_save_files: saving question from editing form from file \'' . $filename_draft . '\'');
            $content = $this->get_file_content($filename_draft);
            $this->loger('import_or_save_files: saving question from editing form from file \'' . $filename_draft . '\'');

            //Ulozenie suboru
            $questiondir = $CFG->dataroot . '/question/' . $COURSE->id . '/' . $itemid . '/';
            $filename =  $questiondir . $itemid;
            $this->save_file($filename, $content);
        } else if (!empty($field['files'])) {
            $this->loger('import_or_save_files: saving question from import');
        // This is the case when we are doing an import.
            foreach ($field['files'] as $file) {
                $this->import_file($context, $component,  $filearea, $itemid, $file);
            }
        }

        $this->loger('import_or_save_files: return text \'' . trim($field['text']) .'\'');
        return trim($field['text']);
    }

    function import_file($context, $component, $filearea, $itemid, $file) {
       global $COURSE;
        $questiondir = $CFG->dataroot . '/question/' . $COURSE->id . '/' .  $itemid . '/' . $itemid;
        $file1 = fopen($questiondir, "w");
        fwrite($file1, $this->decode_file($file));
        fclose($file1);
    }

    /**
     * Save file.
     *
     * @param $filename is full path including file name
     * @param $content id file content
     */
    function save_file($filename, $content)
    {
        $this->loger('save_file: saving file \'' . $filename .'\'' );
        $dirname = dirname($filename);
        if (!is_dir($dirname))
        {
            mkdir($dirname, 0777, true);
        }

        $file = fopen($filename, "w");
        fwrite($file, $content);
        fclose($file);
    }


    /**
     * Logger.
     *
     * @param $filename is full path including file name
     * @param $content id file content
     */
    function loger($log)
    {
        global $CFG;

        $logfile = $CFG->dataroot . '/log/' . $this->name(). '.txt';
        $dirname = dirname($logfile);
        if (!is_dir($dirname))
        {
            mkdir($dirname, 0777, true);
        }

        $file = fopen($logfile, "a");
        fwrite($file, date("d.m.Y H:i:s", time()) . ': ' . $log . "\n");
        fclose($file);
    }

    /**
     * Save file.
     *
     * @param $filename is full path including file name
     * @param $content id file content
     */
    function get_file_content($filename)
    {
        //return file_get_contents($filename);
        $this->loger('get_file_content: Read from file \'' . $filename . '\'');

        $file = fopen($filename, "r");
        $this->loger('get_file_content: fopen with filesize: ' . filesize($filename));
        $content = fread($file, filesize($filename));
        $this->loger('get_file_content: fread');
        fclose($file);

        return $content;
    }

    function decode_file($file) {
        switch ($file->encoding) {
        case 'base64': return base64_decode($file->content);
        default:
            return $file->content;
        }
    }
    
    function get_image_url($questionid, $answerimagefilename) {
        global $CFG,$COURSE;

        $baseurl = $CFG->wwwroot . '/pix/question/' . "$COURSE->id/$questionid/$answerimagefilename";

        if ($options['forcehttps']) {
            $baseurl = str_replace('http://', 'https://', $baseurl);
        }

        return $baseurl;
    }    
    /************************************************************************/

}

// Register this question type with the system.
question_register_questiontype(new it4kt_match_qtype());
?>
