<?php
/**
 * The question type class for the part code question question type.
 *
 * @copyright &copy; 2013 Peter Vaclavik
 * @author peter.vaclavik@tuke.sk
 * @license http://www.gnu.org/copyleft/gpl.html GNU Public License
 * @package it4kt
 *//** */

/**
 * The part code question question class
 *
 * TODO give an overview of how the class works here.
 */
class it4kt_partcode_qtype extends default_questiontype {

    function name() {
        return 'it4kt_partcode';
    }

	/**
     * Allow question types to include required JavaScrip or CSS on pages
     * where they are going to be printed.
     *
     * @param object $question The question object.
     * @param object $state    The state object.
     */
    function get_html_head_contributions(&$question, &$state) {
        global $CFG;
        if (file_exists($CFG->dirroot . '/lib/js/jquery-1.7.1.js')) {
            require_js($CFG->dirroot . '/lib/js/jquery-1.7.1.js');
        } 
        
        $contributions = parent::get_html_head_contributions($question, $state);

        $baseurl = $this->plugin_baseurl();
        echo '<link rel="stylesheet" type="text/css" href="' . $baseurl . '/styles.css" />';
        return $contributions;
        
    }
    
// TODO think about whether you need to override the is_manual_graded or
    // is_usable_by_random methods form the base class. Most the the time you
    // Won't need to.

    /**
     * Loads the question type specific options for the question.
     *
     * This function loads any question type specific options for the
     * question from xml file into the question object. This information
     * is placed in the $question->options field. 
	 *
     * @return bool            Indicates success or failure.
     * @param object $question The question object for the question. 
     */
    function get_question_options(&$question) {
        global $CFG,$COURSE;
        // TODO code to retrieve the extra data you stored in the database into
        // $question->options.
        $this->loger('get_question_options - START');

        $contextid = get_field('question_categories', 'contextid', 'id', $question->category); 
        $context = get_context_instance_by_id($contextid);
//        $files = $this->get_area_files($question->id);
//        foreach ($files as $file) {
//            $targetfile = $file;
//        }

        $question_filename = $CFG->dataroot . '/question/' . $COURSE->id . '/' . $question->id . '/' . $question->id;
        $content = $this->get_file_content($question_filename);
        //create DOM structure from xml
        $this->loger('get_question_options - laoding XML content from file: \'' . $question_filename . '\'');
//        $xml = simplexml_load_string($targetfile->get_content());
        $xml = simplexml_load_string($content);
        $this->loger('get_question_options - XML readed');
        $json = json_encode($xml);
        $this->loger('get_question_options - XML is JSON encoded');
        $array = json_decode($json,TRUE);  
        $this->loger('get_question_options - XML is JSON decoded');
        //file parsing
        $mbpartcode = new stdClass();
        $mbpartcode->type = $array['partcodetype'];
        if($mbpartcode->type == 'text'){		
            $this->loger('get_question_options - TEXT type ');
            $mbpartcode->code = (string) $array['text']['code'];
            $replaces = array();
            foreach($array['text']['replace']['answers'] as $key => $anss){
//                $this->loger('isArray = ' . (is_array($anss) ? 'true' : 'false') . ' = ' . $anss);
                if(is_array($anss)){
                    foreach($anss as $ans){
                        if(is_array($ans)){
                            $answers = array();
                            foreach($ans as $k => $a){                            
                                $answers[$k] = trim($a);
                            }
                        }else{
                            $answers = trim($ans);
                        }
    //                    $this->loger('$replaces[$key]->answers = ' . $ans . ' = ' . $key);
                        $replaces[$key]->answers = $answers;					
                    }
                } else {
                    $replaces[0]->answers = trim($anss);
                }
            }
            $mbpartcode->replace = $replaces;
        }else{
            $this->loger('get_question_options - WS type ');
            $mbpartcode->code = (string) $array['connections']['code'];
            $mbpartcode->check = $array['connections']['check_service'];
            $mbpartcode->control = $array['connections']['control_wsdl'];
            $mbpartcode->method = $array['connections']['control_method'];
            $mbpartcode->param_name = $array['connections']['control_param_name'];
        }
        $question->options->partcode = $mbpartcode;
        $this->loger('get_question_options - END - \'' . $question->options->partcode->type . '\'');
        return true;
    }

    /**
     * Save the units and the answers associated with this question.
     * @param object $question The question object.
     * @return boolean to indicate success of failure.
     */
    function save_question_options($question) {
        $this->loger('save_question_options - START');
        // TODO code to save the extra data to your database tables from the
        // $question object, which has all the post data from editquestion.html
        $context = $question->context;
        //erase file (edit mode)
        $this->delete_question($question->id ,$context->id);
        //set up attibuttes which is needed for file saving	
        $save_file['text']="";
        $save_file['format']= FORMAT_HTML;
        $save_file['itemid']= $question->xmlfile;
        //save file
        $this->import_or_save_files($save_file, $context, 'qtype_it4kt_partcode', 'question', $question->id);
        $this->loger('save_question_options - END');
        return true;
    }

    /**
     * Deletes question from the question-type specific tables
     *
     * @param integer $questionid The question being deleted
     * @return boolean to indicate success of failure.
     */
    function delete_question($questionid) {
        global $CFG, $COURSE;

        $this->loger('delete_question - START');
        $questiondir = $CFG->dataroot . '/question/' . $COURSE->id . '/'. $questionid;
        fulldelete($questiondir);

        $this->loger('delete_question - END');
        return parent::delete_question($questionid, $contextid);
    }

    /**
     * Creates empty session and response information for the question
     *
     * @return bool            Indicates success or failure.
     * @param object $question The question for which the session is to be
     *                         created. 
     * @param object $state    The state to create the session for. 
     * @param object $cmoptions
     * @param object $attempt  The attempt for which the session is to be
     *                         started.
     */
    function create_session_and_responses(&$question, &$state, $cmoptions, $attempt) {
        // TODO create a blank repsonse in the $state->responses array, which
        // represents the situation before the student has made a response.
        $this->loger('create_session_and_responses - START');
    	$state->responses = array();
        $this->loger('create_session_and_responses - END');
        return true;
    }

    /**
     * Restores the session data and most recent responses for the given state
     *
     * @return bool            Indicates success or failure.
     * @param object $question The question object for the question including any
     *                         question type specific information.
     * @param object $state    The saved state to load the session for. 
     */
    function restore_session_and_responses(&$question, &$state) {
        // TODO unpack $state->responses[''], which has just been loaded from the
        // database field question_states.answer into the $state->responses array.
        $this->loger('restore_session_and_responses - START');
        if ($question->options->partcode->type == 'text'){
            if(!empty($state->responses[''])){
                $state->responses = explode(',', $state->responses['']);
                foreach($state->responses as $key => $response){
                    $state->options->correctposition[$key] = 0;
                    $answer = $question->options->partcode->replace[$key]->answers;
                    if(is_array($answer)){
                        foreach($answer as $ans){
                            if(trim($response) == trim($ans)){
                                $state->options->correctposition[$key] = 1;
                                break;
                            }		
                        }	
                    }else if(trim($response) == trim($answer)){
                        $state->options->correctposition[$key] = 1;
                    }
                }			
            }else{
                $state->responses = array();
                foreach($question->options->partcode->replace as $key=>$replace){
                    $state->options->correctposition[$key] = 0;
                }
            }		
        }else{
            if(!empty($state->responses[''])){
                $state->responses = explode(',', $state->responses['']);
                $responses = $state->responses;
                $code = $question->options->partcode->code;
                $replacecount = substr_count($code, '$partcode-replace');
                foreach($responses as $key => $response){
                    $code = str_replace('$partcode-replace'."{$key}",trim($response), $code);
                }
                xdebug_disable();
                try{
                    $client = new SoapClient($question->options->partcode->control);
                    $result = $client->{$question->options->partcode->method}(array($question->options->partcode->param_name=>$code));

                    if($result->return == true){
                        $state->options->correctposition = 1;
                    }else{
                        $state->options->correctposition = 0;
                    }	
                }catch(Exception $e){
                    $state->options->correctposition = 0;
                }	
            } else{
                $state->responses = array();
                $state->options->correctposition = 0;
            }	
        }
        $this->loger('restore_session_and_responses - END');
        return true;
    }

    /**
     * Saves the session data and responses for the given question and state
     *
     * @return bool            Indicates success or failure.
     * @param object $question The question object for the question including
     *                         the question type specific information.
     * @param object $state    The state for which the question type specific
     *                         data and responses should be saved.
     */
    function save_session_and_responses(&$question, &$state) {
        // TODO package up the students response from the $state->responses
        // array into a string and save it in the question_states.answer field.

        $responses = '';

        $this->loger('save_session_and_responses - START');
        $responses  = implode(',', $state->responses);

        set_field('question_states', 'answer', $responses, 'id', $state->id);
//        set_field('question_states', 'answer', $responses, array('id' => $state->id));
        $this->loger('save_session_and_responses - END');
        return true;
        //return set_field('question_states', 'answer', $responses, 'id', $state->id);
    }

     /**
      * Prints the question  grading details, content,
      * feedback and interactions
      *
      * @param object $question The question to be rendered. 
      * @param object $state    The state to render the question in. 
      * @param object $cmoptions
      * @param object $options  An object describing the rendering options.
	  */
    function print_question_formulation_and_controls(&$question, &$state, $cmoptions, $options) {
        global $CFG;
        $this->loger('print_question_formulation_and_controls - START');

        $contextid = get_field('question_categories', 'contextid', 'id', $question->category); 
        $context = get_context_instance_by_id($contextid);
        
        $responses    = $state->responses;
        // Print formulation
        $questiontext = $this->format_text($question->questiontext,
                $question->questiontextformat, $cmoptions);
		
        $a = new stdClass;
        $a->class = '';
        $a->feedbackimg = '';
        $code = $question->options->partcode->code;
        if($question->options->partcode->type == 'text'){
            $this->loger('print_question_formulation_and_controls - TEXT - bez napojenia na webovu sluzbu.');

            foreach ($question->options->partcode->replace as $key => $replace) {
                $this->loger('Responses > 0');
                //print feedback image
                if (($options->feedback) || $options->correct_responses) {
                    $a->feedbackimg = question_get_feedback_image($state->options->correctposition[$key], $options->feedback);
                }

                $name   = "name=\"{$question->name_prefix}{$key}\"";

                $length = 4;
                if(is_array($replace->answers)){
                    foreach($replace->answers as $ans){
                        $lengthi = strlen($ans);
                        if($length < $lengthi){
                            $length = $lengthi;	
                        }		
                    }
                }else{
                    $length = strlen($replace->answers);
                }
                $length = $length + rand(1,3);
                if(count($responses) != 0){
                    $replacestring = "<input size=\"{$length}\" type=\"text\" id=\"{$question->name_prefix}{$key}\"  $name value=\"{$responses[$key]}\"/> {$a->feedbackimg}";	
                }else{
                    $replacestring = "<input size=\"{$length}\" type=\"text\" id=\"{$question->name_prefix}{$key}\"  $name value=\"\"/> {$a->feedbackimg}";
                }
                $code = str_replace('$partcode-replace'."{$key}","{$replacestring}", $code);
            }

            $a->code = '<pre id="code">'."\n\n".$code."\n\n".'</pre>';			
            $anss = clone($a);

            include("$CFG->dirroot/question/type/it4kt_partcode/display.html");
        }else{
            $this->loger('print_question_formulation_and_controls - WS - pouzitie webovej sluzby.');
            if (($options->feedback) || $options->correct_responses) {
                $a->feedbackimg = question_get_feedback_image($state->options->correctposition, $options->feedback);
            }
            $codecheck = $code;
            $replacecount = substr_count($code, '$partcode-replace');
            for ($i = 0; $i < $replacecount; $i++) {
                $name   = "name=\"{$question->name_prefix}{$i}\"";
                $length = 10;
                if(count($responses) != 0){
                    $replacestring = "<input size=\"{$length}\" type=\"text\" id=\"{$question->name_prefix}{$i}\"  $name value=\"{$responses[$i]}\"/>";	
                }else{
                    $replacestring = "<input size=\"{$length}\" type=\"text\" id=\"{$question->name_prefix}{$i}\"  $name value=\"\"/>";
                }
                $codearray = explode('$partcode-replace'."$i",$codecheck);
                $codecheck = trim($codearray[0]).' "+ $('."'"."#{$question->name_prefix}{$i}"."').val() + ".'" ' . trim($codearray[1]);
                $code = str_replace('$partcode-replace'."{$i}","{$replacestring}", $code);
            }
            $codecheck = str_replace("\n"," ", $codecheck);
            $a->codecheck = '"'.$codecheck.'"';
            $a->code = '<pre id="code">'."\n\n".$code."\n\n".'</pre>';	
            $a->check = $question->options->partcode->check;	
            $anss = clone($a);
            include("$CFG->dirroot/question/type/it4kt_partcode/display2.html");
        }		
        
        $this->loger('print_question_formulation_and_controls - END');
    }

    /**
     * Performs response processing and grading
     *
     * @return boolean         Indicates success or failure.
     * @param object $question The question to be graded. Question type
     *                         specific information is included.
     * @param object $state    The state of the question to grade. 
	 * @param object $cmoptions
     */
    function grade_responses(&$question, &$state, $cmoptions) {
        // TODO assign a grade to the response in state.
        $this->loger('grade_responses - START');
        $responses    = $state->responses;
        $sumgrade = 0;
        $totalgrade = 0;
        if($question->options->partcode->type == 'text'){
            foreach($responses as $key => $response){
                $totalgrade++;
                $state->options->correctposition[$key] = 0;
                $answer = $question->options->partcode->replace[$key]->answers;
                if(is_array($answer)){
                    foreach($answer as $ans){
                        if(trim($response) == trim($ans)){
                            $state->options->correctposition[$key] = 1;
                            $sumgrade++;	
                            break;
                        }		
                    }	
                }else if(trim($response) == trim($answer)){
                                $state->options->correctposition[$key] = 1;
                                $sumgrade++;	
                }	
            }
            if($totalgrade != 0){			
                $state->raw_grade = $sumgrade/$totalgrade;
            }else{
                $state->raw_grade = 0;
            }
        }else{
            $code = $question->options->partcode->code;
            $replacecount = substr_count($code, '$partcode-replace');
            foreach($responses as $key => $response){
                $code = str_replace('$partcode-replace'."{$key}",trim($response), $code);
            }

            xdebug_disable();
            try{
                $client = new SoapClient($question->options->partcode->control);
                $result = $client->{$question->options->partcode->method}(array($question->options->partcode->param_name=>$code));
                if($result->return == true){
                    $state->raw_grade = 1.0;	
                    $state->options->correctposition = 1;
                }else{
                    $state->raw_grade = 0.0;	
                    $state->options->correctposition = 0;
                }
            }catch(Exception $e){
                $state->raw_grade = 0.0;	
                $state->options->correctposition = 0;
            }
        }
        // Make sure we don't assign negative or too high marks
        $state->raw_grade = min(max((float) $state->raw_grade,
            0.0), 1.0) * $question->maxgrade;

        // Apply the penalty for this attempt
        $state->penalty = $question->penalty * $question->maxgrade;

        // mark the state as graded
        $state->event = ($state->event ==  QUESTION_EVENTCLOSE) ? QUESTION_EVENTCLOSEANDGRADE : QUESTION_EVENTGRADE;
        $this->loger('grade_responses - END');
        return true;
    }

    /**
     * Compares two question states for equivalence of the student's responses
     *
     * @return boolean          false = odpovede zmenene true = rovnake odpovede
     * @param object $question  The question for which the states are to be
     *                          compared. 
     * @param object $state     The state of the question. 
     * @param object $teststate The state whose responses are to be
     *                          compared. 
	 */
    function compare_responses($question, $state, $teststate) {
        // TODO write the code to return two different student responses, and
        // return two if the should be considered the same.
        $this->loger('compare_responses - START');
        foreach ($state->responses as $key=>$sr) {
            if (empty($teststate->responses[$key])) {
                if (!empty($state->responses[$key])) {
                    return false;
                }
            } else if ($state->responses[$key] != $teststate->responses[$key]) {
                return false;
           }
        }
        $this->loger('compare_responses - END');
        return true;
    }

    /**
     * Checks whether a response matches a given answer, taking the tolerance
     * and units into account. Returns a true for if a response matches the
     * answer, false if it doesn't.
     */
    function test_response(&$question, &$state, $answer) {
        // TODO if your code uses the question_answer table, write a method to
        // determine whether the student's response in $state matches the
        // answer in $answer.
        $this->loger('test_response - START');

        $this->loger('test_response - END');
        return false;
    }

    function check_response(&$question, &$state){
        // TODO
        $this->loger('check_response - START');

        $this->loger('check_response - END');
        return false;
    }

    /**
     * Returns an array of values which will give full marks if graded as
     * the $state->responses field
     *
     * @return mixed           A response array giving the responses corresponding
     *                         to the (or a) correct answer to the question. 
     * @param object $question The question for which the correct answer is to
     *                         be retrieved.
     * @param object $state    The state of the question, for which a correct answer is
     *                         needed. Question type specific information is included.
     */
    function get_correct_responses(&$question, &$state) {
        // TODO
        $this->loger('get_correct_responses - START');
        $responses = array();
        if($question->options->partcode->type == 'text'){
            foreach($question->options->partcode->replace as $key => $replace){
                $answers = $replace->answers;
                foreach($answers as $a){
                    if(is_array($a)){
                        $responses[$key] = $a[0];
                    }else{
                        $responses[$key] = $a;
                    }	
                }			
            }
        }else{
            //must call web service of client and get right answer
            //imposibble if web service try to be only for control.
        }
        $this->loger('get_correct_responses - END');
        return empty($responses) ? null : $responses;  
    }

    function get_all_responses(&$question, &$state) {
        $result = new stdClass;
        // TODO
        $this->loger('get_all_responses - START');

        $this->loger('get_all_responses - END');
        return $result;
    }

    function get_actual_response($question, $state) {
        // TODO
        $this->loger('get_actual_response - START');
        $responses = array();
        if (!empty($state->responses)) {
            foreach ($state->responses as $aid =>$rid){
                    $responses[] = $rid;
            }
        } else {
            $responses[] = '';
        }
        $this->loger('get_actual_response - END');
        return $responses;
    }

    /**
     * Backup the data in the question
     *
     * This is used in question/backuplib.php
     */
    function backup($bf,$preferences,$question,$level=6) {
        $status = true;

        // TODO write code to backup an instance of your question type.
        $this->loger('backup - START');

        $this->loger('backup - END');

        return $status;
    }

    /**
     * Restores the data in the question
     *
     * This is used in question/restorelib.php
     */
    function restore($old_question_id,$new_question_id,$info,$restore) {
        $status = true;

        // TODO write code to restore an instance of your question type.
        $this->loger('restore - START');

        $this->loger('restore - END');

        return $status;
    }

	/**
     * Imports question from the Moodle XML format
     *
     * Imports question using information from extra_question_fields function
     * If some of you fields contains id's you'll need to reimplement this
     */
    function import_from_xml($data, $question, $format, $extra=null) {
        $this->loger('import_from_xml - START');
        if (!array_key_exists('@', $data)) {
            $this->loger('import_from_xml - END - FALSE');
            return false;
        }
        if (!array_key_exists('type', $data['@'])) {
            $this->loger('import_from_xml - END - FALSE');
            return false;
        }
        if ($data['@']['type'] == 'it4kt_partcode') {
            $question = $format->import_headers($data);

            // header parts particular to ordering
            $question->qtype = 'it4kt_partcode';
            
            // get file
            $filexml = $format->getpath($data, array('#', 'file'), array());
            $question->xmlfile = $this->import_files_to_draft_file_area($format, $filexml); //ulozim meno suboru
			                
            $this->loger('import_from_xml - END - TRUE');
            return $question;
        }

        $this->loger('import_from_xml - END - FALSE');
        return false;
    }

    /**
     * Export question to the Moodle XML format
     *
     * Export question using information from extra_question_fields function
     * If some of you fields contains id's you'll need to reimplement this
     */
    function export_to_xml($question, $format, $extra) {
        $this->loger('export_to_xml - START');

        $expout = '';
        $files = get_area_files($question->id);
        
        $expout .= $format->write_files($files);
        
        $this->loger('export_to_xml - END');
        return $expout;
    }


    /************************************************************************/
    /********************** Pridane pomocne funkcie *************************/
    /************************************************************************/
    /**
     * Create a draft files area, import files into it and return the draft item id.
     * @param qformat_xml $format
     * @param array $xml an array of <file> nodes from the the parsed XML.
     * @return integer draftitemid
     */
    function import_files_to_draft_file_area($format, $files) {
        global $CFG,$COURSE,$USER;
        $this->loger('import_files_to_draft_file_area: START');
        foreach ($files as $file) {
            
            $filename = $file['@']['name'];
            
            $questiondir = $CFG->dataroot . '/question/' . $COURSE->id . '/'. $USER->id . '/draft/' . $filename;
            $xmlfile->encoding = $file['@']['encoding'];
            $xmlfile->content = $file['#'];
            $content = $this->decode_file($xmlfile);    
            //Ulozenie suboru
            $this->save_file($questiondir, $content);
        }
        
        return $filename;
    }


    /**
     * Loads directory of files for question type identified by question ID.
     */
    function get_area_files($questionid) {
        global $CFG,$COURSE;
        $this->loger('get_area_files - START');
        $questiondir = $CFG->dataroot . '/question/' . $COURSE->id . '/' . $questionid;

        $questiondir1 = make_upload_directory($questiondir);    
        $this->loger('get_area_files - END - reading directory from: \'' . $questiondir1 . '\'');
        return get_directory_list($questiondir1);
    }

    /**
     * Save the file belonging to one text field.
     *
     * @param array $field the data from the form (or from import). This will
     *      normally have come from the formslib editor element, so it will be an
     *      array with keys 'text', 'format' and 'itemid'. However, when we are
     *      importing, it will be an array with keys 'text', 'format' and 'files'
     * @param object $context the context the question is in.
     * @param string $component indentifies the file area question.
     * @param string $filearea indentifies the file area questiontext, generalfeedback,answerfeedback.
     * @param integer $itemid identifies the file area.
     *
     * @return string the text for this field, after files have been processed.
     */
    function import_or_save_files($field, $context, $component, $filearea, $itemid) {
        global $CFG,$COURSE, $USER;
        if (!empty($field['itemid'])) {
            // This is the normal case. We are safing the questions editing form.

            //Nacitanie obsahu suboru z draft oblasti
            $questiondir_draft = $CFG->dataroot . '/question/' . $COURSE->id . '/'. $USER->id . '/draft/';            
            $filename_draft =  $questiondir_draft . $field['itemid'];
            $this->loger('import_or_save_files: saving question from editing form from file \'' . $filename_draft . '\'');
            $content = $this->get_file_content($filename_draft);
            $this->loger('import_or_save_files: saving question from editing form from file \'' . $filename_draft . '\'');
                        
            //Ulozenie suboru
            $questiondir = $CFG->dataroot . '/question/' . $COURSE->id . '/' . $itemid . '/';
            $filename =  $questiondir . $itemid;
            $this->save_file($filename, $content);
        } else if (!empty($field['files'])) {
            $this->loger('import_or_save_files: saving question from import');
        // This is the case when we are doing an import.
            foreach ($field['files'] as $file) {
                $this->import_file($context, $component,  $filearea, $itemid, $file);
            }
        }
        
        $this->loger('import_or_save_files: return text \'' . trim($field['text']) .'\'');
        return trim($field['text']);
    }     

    function import_file($context, $component, $filearea, $itemid, $file) {
       global $COURSE;
        $questiondir = $CFG->dataroot . '/question/' . $COURSE->id . '/' .  $itemid . '/' . $itemid;
        $file1 = fopen($questiondir, "w");
        fwrite($file1, $this->decode_file($file));
        fclose($file1);            
    }
    
    /**
     * Save file.
     *
     * @param $filename is full path including file name
     * @param $content id file content
     */
    function save_file($filename, $content)
    {
        $this->loger('save_file: saving file \'' . $filename .'\'' );
        $dirname = dirname($filename);
        if (!is_dir($dirname))
        {
            mkdir($dirname, 0777, true);
        }
        
        $file = fopen($filename, "w");
        fwrite($file, $content);
        fclose($file);                
    }

    
    /**
     * Logger.
     *
     * @param $filename is full path including file name
     * @param $content id file content
     */
    function loger($log)
    {
        global $CFG;
        
        $logfile = $CFG->dataroot . '/log/' . $this->name(). '.txt';
        $dirname = dirname($logfile);
        if (!is_dir($dirname))
        {
            mkdir($dirname, 0777, true);
        }
        
        $file = fopen($logfile, "a");
        fwrite($file, date("d.m.Y H:i:s", time()) . ': ' . $log . "\n");
        fclose($file);                
    }

    /**
     * Save file.
     *
     * @param $filename is full path including file name
     * @param $content id file content
     */
    function get_file_content($filename)
    {        
        //return file_get_contents($filename);
        $this->loger('get_file_content: Read from file \'' . $filename . '\'');
        
        $file = fopen($filename, "r");
        $this->loger('get_file_content: fopen with filesize: ' . filesize($filename));
        $content = fread($file, filesize($filename));
        $this->loger('get_file_content: fread');
        fclose($file);                
        
        return $content;
    }
    
    function decode_file($file) {
        switch ($file->encoding) {
        case 'base64': return base64_decode($file->content);
        default:
            return $file->content;
        }
    } 
}
    
    /************************************************************************/

// Register this question type with the system.
question_register_questiontype(new it4kt_partcode_qtype());
?>
